/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content;

import java.util.ArrayList;
import java.util.List;

import org.exoplatform.commons.utils.PageList;

/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *         jobdung@yahoo.com
 * July 13, 2006
 */
public class ContentPageList extends PageList {
  
  private List<Object> list_;
  
  public ContentPageList(List<Object> list){
    super(20);    
    list_ = list;
    setAvailablePage(list_.size());        
  }
  
  public ContentPageList(List<Object> list, int pageSize) {
    super(pageSize);    
    list_ = list;
    setAvailablePage(list_.size());
  }
  
  protected void populateCurrentPage(int page) throws Exception  {
    List<Object> list = new ArrayList<Object>();
    int idx = (page-1)*getPageSize();    
    while(idx < Math.min(getPageSize()*page, getAvailable())){
      list.add(list_.get(idx));
      idx++;
    }
    currentListPage_ = list;
  }
  
  public List getAll() throws Exception  { 
    return new ArrayList<Object>();
  }  

}
