package org.exoplatform.portlets.content.actions.component;

import java.util.Collection;
import java.util.List;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.UIPageListIterator;
import org.exoplatform.faces.core.component.model.PageListDataHandler;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.content.ContentPageList;
import org.exoplatform.portlets.content.admin.component.UIECMAdminSummary;
import org.exoplatform.services.cms.actions.ActionServiceContainer;


public class UIActionTypeList extends UIExoCommand{  
  final static public String ADD_ACTION = "add".intern();    
  public static Parameter[] ADD_PARAMS = { new Parameter(ACTION , ADD_ACTION)} ;
  public static Parameter[] BACK_PARAMS = { new Parameter(ACTION , BACK_ACTION)} ;   
  private ActionServiceContainer actionsServiceContainer_;
  public UIPageListIterator uiPageIterator_ ;  
  
  public UIActionTypeList(ActionServiceContainer actionsServiceContainer) throws Exception{
    setId("UIRuleTypeList") ;
    setRendererType("VelocityRenderer") ;        
    actionsServiceContainer_ = actionsServiceContainer;
    uiPageIterator_ = new UIPageListIterator(new PageListDataHandler()) ;  
    getChildren().add(uiPageIterator_);
    addActionListener(AddActionListener.class, ADD_ACTION) ;
    addActionListener(BackActionListener.class, BACK_ACTION) ;
    uiPageIterator_.setPageList(new ContentPageList(getActions()));  
  }

  public Collection getPageListDataHandler() throws Exception{   
    return uiPageIterator_.getPageListDataHandler().getDatas();        
  }
  
  public Parameter[] getAddParams() { return ADD_PARAMS ; }
  public Parameter[] getBackParams() { return BACK_PARAMS ; }
  
  public boolean hasActions() throws Exception{
     return !actionsServiceContainer_.getCreatedActionTypes().isEmpty();
  }
  
  public List getActions() throws Exception{
    return (List)actionsServiceContainer_.getCreatedActionTypes();
  }

  public void refresh() throws Exception{    
    uiPageIterator_.setPageList(new ContentPageList(getActions()));     
  }
  
  static public class AddActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIActionTypeList uicomp = (UIActionTypeList) event.getComponent() ;
      UIActionTypeFormController actionTypeFormController = (UIActionTypeFormController) uicomp.getSibling(
          UIActionTypeFormController.class);
      actionTypeFormController.showNewActionTypeForm();
      uicomp.setRenderedSibling(UIActionTypeFormController.class);
    }
  }    
  
  static public class BackActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIActionTypeList uicomp = (UIActionTypeList) event.getComponent() ;
      uicomp.setRenderedSibling(UIECMAdminSummary.class);
    }
  }    
  
}