package org.exoplatform.portlets.content.jcr.component;

import java.util.ArrayList;
import java.util.List;
import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.jcr.Node;
import javax.portlet.PortletPreferences;

import org.exoplatform.faces.FacesUtil;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;
import org.exoplatform.portlets.content.jcr.component.UIViewController.CancelActionListener;


public class UIFolderForm extends UISimpleForm implements ChangeNodeListener {

  final static public String INPUT_NAME = "name";   

  protected UISelectBox typeInput_;
  protected UIStringInput nameInput_ ;  
  private String folderTypes_[] = null ;

  public UIFolderForm() throws Exception {
    super("folderForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer");        
    PortletPreferences prefs = FacesUtil.getPortletPreferences() ;
    folderTypes_ = prefs.getValues("folderTypes",null) ;
    List<SelectItem> typeOptions = new ArrayList<SelectItem>() ;
    for(String type:folderTypes_) {
      typeOptions.add(new SelectItem(type,type)) ;
    }      
    typeInput_ = new UISelectBox("folderType","",typeOptions) ;
    add(typeInput_) ;
    if(folderTypes_.length == 1) {
      typeInput_.setValue(folderTypes_[0]) ;
      typeInput_.setRendered(false) ;
    }
    nameInput_ = new UIStringInput("name","") ;
    add(nameInput_);

    addActionListener(AddFolderActionListener.class, SAVE_ACTION);
    addActionListener(CancelActionListener.class, CANCEL_ACTION);
  }

  public boolean isRenderFolderTypes() {
    if(folderTypes_.length==1) return false ;
    return true ;
  }

  public void onChange(UIJCRExplorer uiExplorer, Node node) throws Exception {
    setRendered(false);    
  }

  static public class AddFolderActionListener extends ExoActionListener {

    public void execute(ExoActionEvent event) throws Exception {
      UIFolderForm uicomp = (UIFolderForm) event.getSource();
      UIJCRExplorer uiExplorer = (UIJCRExplorer) uicomp.getAncestorOfType(UIJCRExplorer.class);      
      String name = uicomp.getUIInput(INPUT_NAME).getValue().trim();
      String type = "" ;
      if(uicomp.folderTypes_.length == 1 ) 
        type = uicomp.folderTypes_[0] ;
      else
        type = uicomp.getUISelectBox("folderType").getValue().trim() ;
      Information iprovider = findInformationProvider(uicomp);
      ResourceBundle res = getApplicationResourceBundle() ;
      try {
        Node node = uiExplorer.getSelectNode();        
        node.addNode(name, type);
        if(!uiExplorer.getPreference().isJcrEnable()) uiExplorer.getSession().save() ;
        uiExplorer.broadcastOnChange(node);
        Object[] args = {name,node.getName()} ;
        iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_INFO,
            res.getString("UIFolderForm.msg.add-successfully"),args)) ;
        uicomp.reset() ;
      } catch (Exception e) {        
        JCRExceptionManager.process(iprovider, e);
        return;
      }
    }
  }  
}
