package org.exoplatform.portlets.content.jcr.component;

import java.util.ArrayList;
import java.util.List;
import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.jcr.Session;
import javax.portlet.PortletPreferences;

import org.exoplatform.faces.FacesUtil;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;
import org.exoplatform.services.jcr.RepositoryService;

public class UIJCRConfig extends UISimpleForm{

  private PortletPreferences prefs_ ;
  private UIStringInput pathInput_ ;
  protected RepositoryService repositoryService_ ;

  public UIJCRConfig(RepositoryService repositoryService) throws Exception{
    super("jcrConfigForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer");

    repositoryService_ = repositoryService ;				    
    prefs_ = FacesUtil.getPortletPreferences() ;

    String[] workspaceNames = repositoryService_.getRepository().getWorkspaceNames() ;    
    List<SelectItem> browsingOptions = new ArrayList<SelectItem>() ;    
    for(int i = 0 ;i<workspaceNames.length;i++) {
      browsingOptions.add(new SelectItem(workspaceNames[i],workspaceNames[i])) ;
    }
    String defaultWorkspace = prefs_.getValue(Utils.WORKSPACE_NAME, "") ;		
    UISelectBox uiSelectBrowsingOptions = 
      new  UISelectBox(Utils.WORKSPACE_NAME,defaultWorkspace, browsingOptions) ;
    add(uiSelectBrowsingOptions); 

    String defaultPath = prefs_.getValue(Utils.JCR_PATH,"") ;
    pathInput_ = new UIStringInput(Utils.JCR_PATH,defaultPath) ;
    add(pathInput_) ;

    addActionListener(SaveActionListener.class,SAVE_ACTION) ;
  }
  public static class SaveActionListener extends ExoActionListener {

    public void execute(ExoActionEvent event) throws Exception {
      UIJCRConfig uiconfig = (UIJCRConfig)event.getSource() ;
      ResourceBundle res = getApplicationResourceBundle();
      String workspaceName = uiconfig.getUIInput(Utils.WORKSPACE_NAME).getValue() ;
      String jcrPath = uiconfig.getUIInput(Utils.JCR_PATH).getValue() ;
      if(jcrPath == null || jcrPath.length() == 0) { jcrPath = "/" ; }			
      PortletPreferences prefs= FacesUtil.getPortletPreferences() ;			
      Information iprovider = findInformationProvider(uiconfig);
      Session session = null ;
      try {								
        session = 
          uiconfig.repositoryService_.getRepository().login(workspaceName) ;
        session.getItem(jcrPath) ;        
      }catch (Exception e) {
        if(session !=null) session.logout() ;
        JCRExceptionManager.process(iprovider, e);
        return ;
      }
      session.logout() ;
      prefs.setValue(Utils.WORKSPACE_NAME, workspaceName) ;
      prefs.setValue(Utils.JCR_PATH, jcrPath) ;
      prefs.setValue("views", prefs.getValue("views","")) ;
      prefs.setValue("drive", prefs.getValue("drive","")) ;
      prefs.store() ;
      iprovider.addMessage(
          new ExoFacesMessage(FacesMessage.SEVERITY_INFO,res.getString("UIJCRExplorer.msg.save-session-success")));
    }
  }			
}
