package org.exoplatform.portlets.content.nodetypes.component;

import java.util.ArrayList;
import java.util.List;
import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.jcr.RepositoryException;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;

import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.UICheckBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.services.jcr.core.nodetype.ExtendedNodeTypeManager;
import org.exoplatform.services.jcr.core.nodetype.NodeTypeValue;

public class UINodeTypeImport extends UISimpleForm {
  
  protected NodeTypeManager ntManager_ ;
  private List nodeTypeList_ = new ArrayList() ;
  private static String IMPORT_ACTION = "import" ;
  
  public static Parameter[] IMPORT_PARAMS = { new Parameter(ACTION , IMPORT_ACTION)} ;
  
  public UINodeTypeImport() {
    super("uiNodeTypeImport", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer") ;
    
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
    addActionListener(ImportActionListener.class, IMPORT_ACTION) ;
  }
  
  public void update (List nodeTypeList, NodeTypeManager ntManager) {
    ntManager_ = ntManager ;
    nodeTypeList_ = nodeTypeList ;
    for(int i = 0 ; i < nodeTypeList_.size() ; i ++) {
      NodeTypeValue nodeTypeValue = (NodeTypeValue)nodeTypeList_.get(i) ;
      UICheckBox checkbox = new UICheckBox(nodeTypeValue.getName(), "") ;
      try {
        NodeType register = ntManager.getNodeType(nodeTypeValue.getName()) ;
        if(register != null) {
          checkbox.setEditable(false) ;
        }
      }catch (RepositoryException re){
        checkbox.setEditable(true) ;
      }
      add(checkbox) ;
    }
  }
  
  public List getNodeTypes() {
    return nodeTypeList_ ;
  }
  
  public String getImportParams() { return IMPORT_ACTION ;  }
  
  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UINodeTypeImport uiForm = (UINodeTypeImport) event.getSource() ;
      uiForm.setRenderedSibling(UINodeTypeList.class) ;
    }
  }
  
  static public class ImportActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UINodeTypeImport uiForm = (UINodeTypeImport) event.getSource() ;
      Information iprovider = findInformationProvider(uiForm) ;
      ResourceBundle res = getApplicationResourceBundle() ;
      ExtendedNodeTypeManager extManager = (ExtendedNodeTypeManager)uiForm.ntManager_ ;
      int counter = 0 ;
      for(int i = 0 ; i < uiForm.nodeTypeList_.size() ; i ++){
        NodeTypeValue nodeTypeValue = (NodeTypeValue)uiForm.nodeTypeList_.get(i) ;
        boolean checked = uiForm.getUICheckBox(nodeTypeValue.getName()).getSelect() ;
        if(checked){         
          extManager.registerNodeType(nodeTypeValue, ExtendedNodeTypeManager.IGNORE_IF_EXISTS) ;
          counter += 1 ;          
        }          
      }
      if(counter > 0) {
        String[] count = {String.valueOf(counter)} ;
        iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_INFO,
            res.getString("UINodeTypeImport.msg.nodetype-registered"),count)) ;
      }else{
        iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_WARN ,
            res.getString("UINodeTypeImport.msg.no-nodetype-registered"))) ;
      }
      UINodeTypeList ntList = (UINodeTypeList)uiForm.getSibling(UINodeTypeList.class) ;
      ntList.refresh(null) ;
      uiForm.setRenderedSibling(UINodeTypeList.class) ;
    }    
  }
}
