/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.rules.component;

import javax.jcr.Node;

import org.exoplatform.faces.core.component.UIExoComponentBase;
import org.exoplatform.services.cms.rules.RuleService;

/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 * @email:   jobdung@yahoo.com
 * @version: $Id: UIRuleFormController.java,v 1.0 2006/08/20 11:11:14 dunghoang Exp $
 */

public class UIRuleFormController extends UIExoComponentBase {
  protected RuleService ruleService_;
  protected Node node_;
  public UIRuleFormController(RuleService ruleService) throws Exception {
    ruleService_ = ruleService;    
    setRendererType("ChildrenRenderer") ;
    addChild(UISelectRuleVersionForm.class) ;
    addChild(UIRuleForm.class) ;
  }
 
  public void showEditRuleForm(String name) throws Exception {        
    UISelectRuleVersionForm uiSelect = 
      (UISelectRuleVersionForm) getChildComponentOfType(UISelectRuleVersionForm.class);
    node_ = ruleService_.getRuleNode(name);  
    boolean isVersioned = node_.isNodeType("mix:versionable");
    if (isVersioned) {
      uiSelect.setRendered(true) ; 
      uiSelect.setRule(name);
    }else{
      uiSelect.setRendered(false) ;
    }    
    UIRuleForm ruleForm = (UIRuleForm) getChildComponentOfType(UIRuleForm.class);   
    ruleForm.setRule(name,null);
  }

  public void showNewRuleForm() throws Exception {
    UISelectRuleVersionForm uiSelect = 
      (UISelectRuleVersionForm) getChildComponentOfType(UISelectRuleVersionForm.class);
    uiSelect.setRendered(false) ;
    UIRuleForm ruleForm = 
      (UIRuleForm) getChildComponentOfType(UIRuleForm.class);
    ruleForm.setRule(null,null);
  }
  
}