package org.exoplatform.portlets.content.search.component;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import javax.jcr.Node;
import javax.jcr.NodeIterator;
import javax.jcr.query.QueryResult;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;
import org.exoplatform.portlets.content.jcr.component.UIJCRExplorer;

public class UIResults extends UIExoCommand {
  
  protected QueryResult results_;
  protected long duration_;  
  protected Map resultMap_ = new HashMap() ;
  
  static Parameter[] CHANGE_NODE_PARAMS = { new Parameter(ACTION,
      UIJCRExplorer.CHANGE_NODE_ACTION) };    
  
  public UIResults() {
    setId("UIResults") ;
    setRendererType("VelocityRenderer") ;    
    addActionListener(ChangeNodeActionListener.class, UIJCRExplorer.CHANGE_NODE_ACTION);
  }
  
  public Parameter[] getChangeNodeParams() { return CHANGE_NODE_PARAMS; }    
  
  public boolean hasResults() throws Exception {
    if(resultMap_.size() > 0) return true ;
    return false ;
  }
  
  public long searchTime() { return duration_; }
  
  public Collection<Node> getNodeIterator() throws Exception {
    return resultMap_.values() ;
  }

  public void setQueryResults(long duration, QueryResult queryResult) throws Exception {
    duration_ = duration;
    if(queryResult != null){
      NodeIterator iter = queryResult.getNodes() ;
      while(iter.hasNext()){
        Node node = iter.nextNode() ;
        resultMap_.put(node.getPath(), node) ;
        
      }
    }
  }  
  
  static public class ChangeNodeActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIResults uicomp = (UIResults) event.getComponent();
      UIJCRExplorer uiExplorer = (UIJCRExplorer) uicomp
          .getAncestorOfType(UIJCRExplorer.class);
      String uri = event.getParameter(OBJECTID);
      Information iprovider = findInformationProvider(uicomp);
      try {
        if ("../".equals(uri)) {
          if (!"/".equals(uiExplorer.getSelectNode().getPath())) {
            uiExplorer.setSelectNode(uiExplorer.getSelectNode().getParent());
          }
        }
        uiExplorer.setSelectNode(uri);
      } catch (Exception e) {
        JCRExceptionManager.process(iprovider, e);
      }
    }
  }
}
