/*
 * Created on Apr 8, 2005
 */
package org.exoplatform.portlets.content.templates.component;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.Session;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeIterator;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.version.VersionException;

import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.Selector;
import org.exoplatform.faces.core.SelectorHandler;
import org.exoplatform.faces.core.component.UICheckBox;
import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.UITextArea;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.user.component.UIExoPermissionBrowser;
import org.exoplatform.faces.user.component.UIExoPermissionSelector;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;
import org.exoplatform.portlets.content.versions.component.VersionNode;
import org.exoplatform.services.cms.BasePath;
import org.exoplatform.services.cms.CmsConfigurationService;
import org.exoplatform.services.cms.scripts.ScriptService;
import org.exoplatform.services.cms.templates.TemplateService;
import org.exoplatform.services.jcr.RepositoryService;
import org.exoplatform.services.jcr.impl.core.SessionDataManager;

/**
 * @author benjaminmestrallet
 */
public class UITemplateForm extends UISimpleForm implements SelectorHandler{

  static String TEMPLATE_NAME = "template".intern(), IS_DOCUMENT_TEMPLATE = "isDocumentTemplate".intern(),
                CONTENT = "content".intern(), VIEW = "viewPermission";

  static String  SEARCH_GROUP = "searchGroup".intern() ;
  static String TEMPLATE_ENABLE_VERSIONING = "enableVersioning";
  static String RESTORE_VERSION_ACTION = "restoreVersion".intern() ;

  protected UIStringInput templateNameInput_;
  protected UICheckBox isDocumentTemplate_;
  protected UITextArea templateContentInput_;
  protected TemplateService templateService_;
  protected String nodeType_;

  static String WIZARD_PRENODESAVE = "PreNodeSave", WIZARD_POSTNODESAVE = "PostNodeSave",
                WIZARD_NODETYPE = "nodetype", WIZARD_MIXINTYPE = "mixintype",
                WIZARD_SCRIPT = "script", WIZARD_WIDGET = "widget",
                WIZARD_EDITABLE = "editable", WIZARD_VISIBLE = "visible",
                WIZARD_INPUTNAME = "inputName", WIZARD_JCRPATH = "jcrPath",
                WIZARD_OPTIONS = "options", WIZARD_SELECTORACTION = "selectorAction",
                WIZARD_SELECTORCLASS = "selectorClass", WIZARD_SELECTORLABEL = "selectorLabel",
                WIZARD_SELECTORPARAMS = "selectorParams", WIZARD_SCRIPTPARAMS = "scriptParams",
                WIZARD_MULTIVALUES = "multiValues", WIZARD_DEFAULTVALUE = "defaultValue",
                WIZARD_LABEL = "label", WIZARD_TITLEWIZARD = "title";

  protected UISelectBox wizard_PreNodeSave_ ;
  protected UISelectBox wizard_PostNodeSave_ ;
  protected UISelectBox wizard_nodetype_ ;
  protected UISelectBox wizard_mixintype_ ;
  protected UISelectBox wizard_script_ ;
  protected UISelectBox wizard_widget_ ;
  protected UISelectBox wizard_editable_ ;
  protected UISelectBox wizard_visible_ ;
  protected UIStringInput wizard_label_;
  protected UIStringInput wizard_inputName_;
  protected UIStringInput wizard_jcrPath_;
  protected UIStringInput wizard_options_;
  protected UIStringInput wizard_selectorAction_;
  protected UIStringInput wizard_selectorClass_;
  protected UIStringInput wizard_selectorLabel_;
  protected UIStringInput wizard_selectorParams_;
  protected UIStringInput wizard_scriptParams_;
  protected UIStringInput wizard_multiValues_;
  protected UIStringInput wizard_defaultValue_;
  protected UIStringInput wizard_titleWizard_;

  protected ScriptService scriptService_;
  protected CmsConfigurationService cmsConfigService_;
  protected RepositoryService repositoryService_;

  protected String templateType_;
  protected String templateName_;

  private boolean isDialog_;

  protected UIExoPermissionSelector permSelector_;
  protected UICheckBox templateEnableVersioning_;
  protected Node node_;
  protected boolean newTemplate_;
  private Node frozenNode_ ;
  protected VersionNode rootVersion_;
  protected VersionNode selectedVersion_;

  protected SessionDataManager dataManager;

  public UITemplateForm(TemplateService templateService, ScriptService sService, CmsConfigurationService cmsConfigService, RepositoryService repositoryService) throws Exception {
    super("templateForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer");

    templateService_ = templateService;

    templateNameInput_ = new UIStringInput(TEMPLATE_NAME, "");
    isDocumentTemplate_ = new UICheckBox(IS_DOCUMENT_TEMPLATE, "") ;
    templateContentInput_ = new UITextArea(CONTENT, "");
    templateContentInput_.setClazz("large");
    permSelector_ = new UIExoPermissionSelector(VIEW, null) ;
    //permSelector_.addValidator(PermissionValidator.class) ;
    isDocumentTemplate_.setEditable(false) ;
    add(isDocumentTemplate_) ;
    add(templateNameInput_);
    add(permSelector_) ;
    add(templateContentInput_);
    templateEnableVersioning_ = new UICheckBox(TEMPLATE_ENABLE_VERSIONING, null);
    templateEnableVersioning_.setSelect(false) ;
    add(templateEnableVersioning_) ;

    wizard_PreNodeSave_= new UISelectBox(WIZARD_PRENODESAVE,"", new ArrayList<SelectItem>());
    add(wizard_PreNodeSave_);
    wizard_PostNodeSave_= new UISelectBox(WIZARD_POSTNODESAVE,"", new ArrayList<SelectItem>());
    add(wizard_PostNodeSave_);
    wizard_nodetype_ = new UISelectBox(WIZARD_NODETYPE,"", new ArrayList<SelectItem>());
    add(wizard_nodetype_);
    wizard_mixintype_ = new UISelectBox(WIZARD_MIXINTYPE,"", new ArrayList<SelectItem>());
    add(wizard_mixintype_);
    wizard_editable_ = new UISelectBox(WIZARD_EDITABLE,"", new ArrayList<SelectItem>());
    add(wizard_editable_);
    wizard_visible_ = new UISelectBox(WIZARD_VISIBLE,"", new ArrayList<SelectItem>());
    add(wizard_visible_);
    wizard_script_ = new UISelectBox(WIZARD_SCRIPT,"", new ArrayList<SelectItem>());
    add(wizard_script_);
    wizard_widget_ = new UISelectBox(WIZARD_WIDGET,"", new ArrayList<SelectItem>());
    add(wizard_widget_);
    wizard_label_ = new UIStringInput(WIZARD_LABEL, "");
    add(wizard_label_);
    wizard_inputName_ = new UIStringInput(WIZARD_INPUTNAME, "");
    add(wizard_inputName_);
    wizard_jcrPath_ = new UIStringInput(WIZARD_JCRPATH, "/node/");
    add(wizard_jcrPath_);
    wizard_options_ = new UIStringInput(WIZARD_OPTIONS, "");
    add(wizard_options_);
    wizard_scriptParams_ = new UIStringInput(WIZARD_SCRIPTPARAMS, "");
    add(wizard_scriptParams_);
    wizard_selectorAction_ = new UIStringInput(WIZARD_SELECTORACTION, "");
    add(wizard_selectorAction_);
    wizard_selectorClass_ = new UIStringInput(WIZARD_SELECTORCLASS, "");
    add(wizard_selectorClass_);
    wizard_selectorLabel_ = new UIStringInput(WIZARD_SELECTORLABEL, "");
    add(wizard_selectorLabel_);
    wizard_selectorParams_ = new UIStringInput(WIZARD_SELECTORPARAMS, "");
    add(wizard_selectorParams_);
    wizard_multiValues_ = new UIStringInput(WIZARD_MULTIVALUES, "");
    add(wizard_multiValues_);
    wizard_defaultValue_ = new UIStringInput(WIZARD_DEFAULTVALUE, "");
    add(wizard_defaultValue_);
    wizard_titleWizard_ = new UIStringInput(WIZARD_TITLEWIZARD, "");
    add(wizard_titleWizard_);

    scriptService_= sService;
    cmsConfigService_= cmsConfigService;
    repositoryService_ = repositoryService;

    addActionListener(SearchGroupActionListener.class, SEARCH_GROUP) ;
    addActionListener(SaveActionListener.class, SAVE_ACTION);
    addActionListener(CancelActionListener.class, CANCEL_ACTION);
    addActionListener(RestoreVersionActionListener.class, RESTORE_VERSION_ACTION);
  }

  public String getSearchGroup() { return SEARCH_GROUP; }
  public String getRestoreVersionAction() { return RESTORE_VERSION_ACTION; }

  public boolean isNewTemplate() throws Exception {
    return newTemplate_;
  }

  public boolean isVersioned() throws RepositoryException {
    if (!newTemplate_) {
      return node_.isNodeType("mix:versionable");
    }
    return false;
  }

  public boolean canEnableVersionning() throws Exception {
    return node_.canAddMixin("mix:versionable");
  }

  public boolean isEnableRestoring() throws Exception {
    if (isVersioned()) {
      long versionSize = node_.getVersionHistory().getAllVersions().getSize();
      if (versionSize > 2) {
        return true;
      }
    }
    return false;
  }

  public void editTemplate(boolean isDialog, String nodeType, String templateName, VersionNode selectedVersion) throws Exception{
    isDialog_ = isDialog;
    nodeType_ = nodeType;
    templateName_ = templateName;
    templateNameInput_.setText(templateName).setEditable(false);
    String templateText = templateService_.getTemplate(isDialog, nodeType_,templateName_);
    String templateRole = templateService_.getTemplateRoles(isDialog, nodeType_, templateName_) ;
    permSelector_.setValue(templateRole) ;
    templateContentInput_.setText(templateText);
    if(isDocumentTemplate(nodeType))
      isDocumentTemplate_.setSelect(true) ;
    else
      isDocumentTemplate_.setSelect(false) ;
    node_ = templateService_.getTemplateNode(isDialog, nodeType_,templateName_);
    newTemplate_ = false;
    if (isVersioned()) {
      if (selectedVersion != null) {
        selectedVersion_ = selectedVersion;
        frozenNode_ = selectedVersion_.getVersion().getNode("jcr:frozenNode") ;
        templateText = frozenNode_.getProperty("exo:templateFile").getString();
        templateNameInput_.setText(templateName).setEditable(false);
        templateContentInput_.setText(templateText);
      }
      templateEnableVersioning_.setSelect(true);
      templateEnableVersioning_.setEditable(false);
    } else if (canEnableVersionning()){
      templateEnableVersioning_.setSelect(false);
      templateEnableVersioning_.setEditable(true);
    }
    if (isEnableWizard()){
      updateWizard();
    }
  }

  public void addTemplate(boolean isDialog, String nodeType) throws Exception{
    newTemplate_ = true;
    isDialog_ = isDialog;
    nodeType_ = nodeType;
    templateName_ = null;
    permSelector_.setValue(null);
    templateNameInput_.setText("").setEditable(true);
    templateContentInput_.setText("");
    if(isDocumentTemplate(nodeType))
      isDocumentTemplate_.setSelect(true);
    else
      isDocumentTemplate_.setSelect(false);
    if (isEnableWizard()){
      updateWizard();
    }
  }

  private boolean isDocumentTemplate(String nodeType) throws Exception{
    return templateService_.getDocumentTemplates().contains(nodeType);
  }

  public void cancel(Selector selector) {
    selector.setRenderedSibling(UITemplateFormController.class) ;
  }

  public void select(Selector selector) throws Exception {
    UIExoPermissionBrowser browser = (UIExoPermissionBrowser)selector ;
    if(browser.isGroup()) {
      permSelector_.setPermission(selector.getInputValue());
    }else {
      permSelector_.setValue(browser.getSelectedUser()) ;
    }
    selector.setRenderedSibling(UITemplateFormController.class);    
  }

  static public class RestoreVersionActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UITemplateForm uiForm = (UITemplateForm) event.getSource();
      ResourceBundle res = getApplicationResourceBundle() ;
      Information iprovider = findInformationProvider(uiForm);
      try {
        if (uiForm.selectedVersion_ != null) {
          Session session = uiForm.repositoryService_.getRepository().getSystemSession(uiForm.cmsConfigService_.getWorkspace()) ;
          Node restored = (Node)session.getItem(uiForm.node_.getPath());
          restored.restore(uiForm.selectedVersion_.getVersion(),true) ;
          restored.checkout() ;
          session.save();
          session.logout() ;          
          Object[] args = {uiForm.selectedVersion_.getName()};
          iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_INFO,
                                     res.getString("UITemplateForm.msg.version-restored"), args));
        }
        UITemplateFormController templateFormController = (UITemplateFormController) uiForm.getParent();
        templateFormController.setRenderedSibling(UIListsManager.class);

      } catch (VersionException ex) {
        iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_ERROR,ex.getMessage()));
      } catch (Exception e) {
        JCRExceptionManager.process(iprovider, e);
      }
    }
  }

  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      ResourceBundle res = getApplicationResourceBundle() ;
      UITemplateForm uiForm = (UITemplateForm) event.getSource();
      String content = uiForm.getUIStringInput(CONTENT).getValue();
      UIStringInput inputString = uiForm.getUIStringInput(TEMPLATE_NAME);
      Information iprovider = findInformationProvider(uiForm);
      String userOrGroup = uiForm.permSelector_.getValue();
      if (userOrGroup == null || userOrGroup.length() == 0) {
        iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_ERROR ,
            res.getString("UITemplateForm.msg.userOrGroup-is-null")));
        return;
      }
      try {
        String name = null;
        if (inputString.isEditable())
          name = inputString.getText();
        else
          name = uiForm.templateName_;
        if (name == null || name.length() < 1) {
          iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_ERROR ,
              res.getString("UITemplateForm.msg.view-name-invalid"))) ;
          return ;
        }
        String[] roles = { userOrGroup };
        boolean isRuleEnableVersioning = uiForm.templateEnableVersioning_.getSelect();
        uiForm.templateService_.
                       addTemplate(uiForm.isDialog_, uiForm.nodeType_, null, false,name, roles, content,isRuleEnableVersioning);        
        UITemplateFormController templateFormController = (UITemplateFormController) uiForm.getParent();
        templateFormController.setRenderedSibling(UIListsManager.class);
      } catch (Exception e) {        
        JCRExceptionManager.process(iprovider, e);
      }
    }
  }

  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UITemplateForm uiForm = (UITemplateForm) event.getComponent();
      UITemplateFormController listManager = (UITemplateFormController) uiForm.getParent();
      listManager.setRenderedSibling(UIListsManager.class);
    }
  }

  static public class SearchGroupActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UITemplateForm uiForm = (UITemplateForm) event.getSource();
      UITemplateFormController templateFormController = (UITemplateFormController) uiForm.getParent();      
      UIExoPermissionBrowser uiGroupBrowser = (UIExoPermissionBrowser) templateFormController
      .getSibling(UIExoPermissionBrowser.class);           
      uiGroupBrowser.setHandler(uiForm);
      templateFormController.setRenderedSibling(UIExoPermissionBrowser.class);  
    }
  }

  public boolean isEnableWizard(){
    return isDialog_;
  }
  public void updateWizardNodeSaveOptions() throws Exception {
    List<SelectItem> wizard_PreNodeSave_options = new ArrayList<SelectItem>();
    List<SelectItem> wizard_PostNodeSave_options = new ArrayList<SelectItem>();
    try{
      String path = cmsConfigService_.getJcrPath(BasePath.CMS_SCRIPTS_PATH) ;
      Iterator  iter= scriptService_.getECMInterceptorScripts().iterator();
      while (iter.hasNext()){
        Node node = (Node)iter.next();
        String interceptorPath = node.getPath().substring(path.length()+1);
        wizard_PreNodeSave_options.add(new SelectItem(interceptorPath ,interceptorPath));
        wizard_PostNodeSave_options.add(new SelectItem(interceptorPath ,interceptorPath));
      }
      wizard_PreNodeSave_.setOptions(wizard_PreNodeSave_options);
      wizard_PostNodeSave_.setOptions(wizard_PostNodeSave_options);
    }catch (Exception e) {
    }
  }

  public void updateWizardNodeTypeOptions() throws Exception {        
    NodeTypeManager nodeTypeManager = repositoryService_.getRepository().getNodeTypeManager() ;
    List<SelectItem> options = new ArrayList<SelectItem>();
    options.add(new SelectItem("", ""));
    for(NodeTypeIterator iter = nodeTypeManager.getAllNodeTypes(); iter.hasNext();) {
      NodeType nodeType = iter.nextNodeType();
      String nodeTypeName = nodeType.getName();
      options.add(new SelectItem(nodeTypeName, nodeTypeName));
    }
    wizard_nodetype_.setOptions(options) ;   
  }

  public void updateWizardMixinTypeOptions() throws Exception {
    List<SelectItem> options = new ArrayList<SelectItem>();
    options.add(new SelectItem("", ""));
    NodeTypeManager nodeTypeManager = repositoryService_.getRepository().getNodeTypeManager() ;    
    NodeTypeIterator ntIter = nodeTypeManager.getAllNodeTypes() ;
    while(ntIter.hasNext()) {
      NodeType nt = ntIter.nextNodeType() ;
      if(nt.isMixin()){
        String ntName = nt.getName() ;
        options.add(new SelectItem(ntName, ntName));
      }
    }
    wizard_mixintype_.setOptions(options);    
  }

  public void updateWizardScriptOptions() throws Exception {
    List<SelectItem> options = new ArrayList<SelectItem>();
    options.add(new SelectItem("", ""));
    try{
      String path = cmsConfigService_.getJcrPath(BasePath.CMS_SCRIPTS_PATH) ;
      Iterator  iter= scriptService_.getECMWidgetScripts().iterator();
      while (iter.hasNext()){
        Node node = (Node)iter.next();
        String item = node.getPath().substring(path.length()+1);
        options.add(new SelectItem(item ,item));
      }
      wizard_script_.setOptions(options);
    }catch (Exception e) {
    }
  }

  public void updateWizardWidgetOptions() throws Exception {
    List<SelectItem> options = new ArrayList<SelectItem>();
    options.add(new SelectItem("", ""));
    options.add(new SelectItem("calendar", "calendar"));
    options.add(new SelectItem("selectbox", "selectbox"));
    options.add(new SelectItem("text", "text"));
    options.add(new SelectItem("textarea", "textarea"));
    options.add(new SelectItem("upload", "upload"));
    options.add(new SelectItem("wysiwyg", "wysiwyg"));
    wizard_widget_.setOptions(options);
  }
  public void updateWizardVisibleOptions() throws Exception {
    List<SelectItem> options = new ArrayList<SelectItem>();
    options.add(new SelectItem("true", "true"));
    options.add(new SelectItem("if-not-null", "if-not-null"));
    wizard_visible_.setOptions(options);
  }
  public void updateWizardEditableOptions() throws Exception {
    List<SelectItem> options = new ArrayList<SelectItem>();
    options.add(new SelectItem("true", "true"));
    options.add(new SelectItem("false", "false"));
    wizard_editable_.setOptions(options);
  }
  public void updateWizard() throws Exception {
    updateWizardNodeSaveOptions();
    updateWizardNodeTypeOptions();
    updateWizardMixinTypeOptions();
    updateWizardScriptOptions();
    updateWizardWidgetOptions();
    updateWizardVisibleOptions();
    updateWizardEditableOptions();
  }
}
