//////////////////////////////////////////////////////
// File: wizard.js
//
// Author: Nguyen Quang Thang
//				 thang.nguyen@exoplatform.com
// Date: Sept 7, 2006
//
// Purpose: To create wizard for dialog template editor
//
//////////////////////////////////////////////////////
var buttonTab
var preWizardText = ''
var tabText = '  '
var wizardForm
var wizardEditor
function is_empty(txt)
{
  // Use ECMA-262 Edition 3 String and RegExp features
  return !(/[^\t\n\r ]/.test(txt));
}
function trim(string){
string = ltrim(string);
return rtrim(string);
}

function rtrim(string){
while(is_empty(string.charAt((string.length -1)))){
string = string.substring(0,string.length-1);
}
return string;
}
function ltrim(string){
while(is_empty(string.charAt(0))){
string = string.replace(string.charAt(0),"");
}
return string;
}

function clearTab(block){
	var tabs = block.childNodes
  for(var i = 0; i < tabs.length; i++){
  	if (tabs[i].nodeType == 1){
    	tabs[i].style.backgroundColor='#ECE9D8'
		}
  }
}
function setTab(btn){
	buttonTab = btn
	clearTab(btn.parentNode)
	btn.style.backgroundColor=btn.parentNode.style.backgroundColor
}
function showWizardBlock(blockID,preText){
	preWizardText = preText
	document.getElementById('visibleBlock').innerHTML = '<form id="wizardForm_" name="wizardForm_" >' + document.getElementById(blockID).innerHTML + '</form>'
	wizardForm = document.getElementById('wizardForm_')
}
function setEditor(wizardEditorID){
	if (wizardEditor == null){
		wizardEditor = document.getElementById(wizardEditorID)
	}
}
function writetoEditor(insertText){
	if (insertText == '') return
	wizardEditor.value += insertText
	buttonTab.onclick() //wizardForm.reset()
	wizardEditor.scrollTop = wizardEditor.scrollHeight
	wizardEditor.focus()
}
function onDisplay(arr){
	for (i in arr){
		arr[i].parentNode.style.display=''
	}
}
function offDisplay(arr){
	for (i in arr){
		arr[i].parentNode.style.display='none'
	}
}
function changeWidgetOfHiddenFields(){
	with (wizardForm){
		var value = widget.value
		var onWidget = [  ]
		var offWidget = [ nodetype, mixintype ]
		if (value == ''){
			onDisplay(offWidget)
			offDisplay(onWidget)
			return
		}else{
			onDisplay(onWidget)
			offDisplay(offWidget)
		}
	}
}
var textOptions = null
var selectboxCalendarOptions = '<select name="options"><option selected="selected" value=""></option><option value="displaytime">displaytime</option></select>'
var selectboxWYSIWYGOptions = '<select name="options"><option selected="selected" value="default">default</option><option value="basic">basic</option><option value="input-only">input-only</option></select>'

function switchOptions(txt){
	var block = wizardForm.options.parentNode
	if (textOptions == null ){
		textOptions = block.innerHTML
	}
	if (txt == ''){
		block.innerHTML = textOptions
		return
	}
	block.removeChild(wizardForm.options)
	block.innerHTML += txt
}
function changeVisibleOfRow(){
	with (wizardForm){
		var onVisible = [ widget , defaultValue ]
		if (visible.value =='true'){
			onDisplay(onVisible)
			editable.value = 'true'
		}else{
			offDisplay(onVisible)
			editable.value = 'false'
		}
	}
}
function changeWidgetOfRow(){
	with (wizardForm){
		var value = widget.value
		var offWidget = [ nodetype, mixintype, selectorAction, selectorLabel, selectorClass, selectorParams, multiValues ]
		var onSelectbox = [ script, scriptParams ]
		var onOptions = [ options ]
		var offUpload = [ editable, defaultValue ]
		if ( value == 'selectbox'){
			onDisplay(onSelectbox)
			onDisplay(onOptions)
			switchOptions('')
		}else{
			offDisplay(onSelectbox)
		}
		if (value == ''){
			onDisplay(offWidget)
			offDisplay(onOptions)
			return
		}else{
			offDisplay(offWidget)
			if ( value == 'upload'){
				offDisplay(offUpload)
				offDisplay(onOptions)
				return
			}
			onDisplay(offUpload)
			if ( value == 'calendar' ){
				onDisplay(onOptions)
				switchOptions(selectboxCalendarOptions)
				return
			}
			if ( value == 'wysiwyg' ){
				onDisplay(onOptions)
				switchOptions(selectboxWYSIWYGOptions)
				return
			}
			if ( value != 'selectbox'){
				offDisplay(onOptions)
			}
		}
	}
}
function getInterceptorWizardValues(){0
	var rs = ''
	rs = rs + '#' + preWizardText + '('
	rs = rs + '"' + wizardForm.elements[0].value + '" '
	rs = rs + '"' + wizardForm.elements[1].value + '"'
	rs = rs + ')\r\n'
	return rs
}
function checkOptions(str_defaultValue,str_options){
	str_defaultValue = trim(str_defaultValue)
	str_options = trim(str_options)
	var arrStr = str_options.split(",");
	for(var i=0;i < arrStr.length;i++){
		if (trim(arrStr[i]) == str_defaultValue){
			return true
		}
	}
	return false
}
function checkJSFDialogFormField(){
	field = wizardForm.inputName
	if (is_empty(field.value)){
		alert(field.name + ' can not be empty')
		field.value=''
		field.focus()
		return false
	}
	field = wizardForm.jcrPath
	if (is_empty(field.value)){
		alert(field.name + ' can not be empty')
		field.value=''
		field.focus()
		return false
	}
	return true
}
function getWizardFormValue(index){
	var rs = ''
	for ( i=index; i<wizardForm.length; i++ ) {
		field = wizardForm.elements[i]
		if ( !is_empty(field.value) && (field.parentNode.style.display != 'none') ){
			if (field.name != 'defaultValue'){
				rs = rs + '"' + field.name + '=' + field.value + '" '
			}else{
				rs = rs + '"' + field.value + '" '
			}
		}
	}
return rs
}
function getHiddenFieldsWizardValues(){
	if (!checkJSFDialogFormField()) return ''
	var rs = ''
	rs = rs + '#' + preWizardText + '('
	rs = rs + getWizardFormValue(0)
	rs = rs + ' "visible=false" )\r\n'
	return rs
}

function getTitleWizardValues(){
	var rs = tabText
	rs = rs + '<div class="title">'
	rs = rs + wizardForm.elements[0].value
	rs = rs + '</div>\r\n'
	return rs
}

function getRowWizardValues(){
	if (!checkJSFDialogFormField()) return ''
	with (wizardForm){
		if ( widget.value=='selectbox'){
			if (is_empty(script.value) && is_empty(options.value)){
				alert('the Widget field is selectbox so the script field or the options field must has value')
				return ''
			}
			if ( is_empty(script.value) &&
					 !is_empty(options.value) &&
					 !is_empty(defaultValue.value) &&
					 !checkOptions(defaultValue.value,options.value)
					){
				alert('the Widget field is selectbox so value of the defaultValue field must be one of values of the options field')
				return ''
			}
		}
		var rs = ''
		if (wizardEditor.value.indexOf('<div class="detail">') == -1){
			rs = rs + tabText + '<div class="detail">\r\n'
		}
		rs = rs + tabText + tabText + '<div class="row">\r\n'
		if (!is_empty(label.value)){
			rs = rs + tabText + tabText + tabText + '<label>' + elements[0].value + '</label>\r\n'
		}
	}
	rs = rs + tabText + tabText + tabText + '#' + preWizardText + '('
	rs = rs + getWizardFormValue(1)
	rs = rs + ' )\r\n' + tabText + tabText + '</div>\r\n'
	return rs
}

function finishWizard(){
	if (wizardEditor.value.indexOf('<div class="detail">') != -1){
		wizardEditor.value += tabText + '</div>\r\n'
	}
	document.getElementById('visibleBlock').innerHTML = ''
}
