/*
 * Created on Feb 14, 2005
 */
package org.exoplatform.portlets.workflow.component;

import java.util.List;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.workflow.WorkflowServiceContainer;


/**
 * @author benjaminmestrallet
 */
public class UIMonitor extends UIExoCommand{
  static String SHOW_PROCESS = "showProcess" ;
  static String SHOW_PROCESS_DETAIL = "showDetailProcess" ;
  static String SHOW_TASKS = "showTasks" ;
  static String DELETE_PROCESS = "deleteProcess";
  static String DELETE_PROCESS_INSTANCE = "deleteProcessInstance";
  
  static Parameter[] SHOW_PROCESS_PARAMS = { new Parameter(ACTION , SHOW_PROCESS)} ;
  static Parameter[] SHOW_PROCESS_DETAIL_PARAMS = { new Parameter(ACTION , SHOW_PROCESS_DETAIL)} ;
  static Parameter[] SHOW_TASKS_PARAMS = { new Parameter(ACTION , SHOW_TASKS)} ;
  static Parameter[] DELETE_PROCESS_PARAMS = { new Parameter(ACTION, DELETE_PROCESS)} ;
  static Parameter[] DELETE_PROCESS_INSTANCE_PARAMS = { new Parameter(ACTION, DELETE_PROCESS_INSTANCE)} ;
  
  String view_  = SHOW_PROCESS ;
  List processDetail_ ;
  List tasks_ ;
  WorkflowServiceContainer workflowServiceContainer_;
  String processDef_;
  
  public UIMonitor(){
    setId("UIMonitor");
    setRendererType("VelocityRenderer") ;
    
    workflowServiceContainer_ = 
      (WorkflowServiceContainer) PortalContainer.getComponent(WorkflowServiceContainer.class);     
    
    addActionListener(ShowActionListener.class, SHOW_PROCESS) ;
    addActionListener(ShowDetailActionListener.class, SHOW_PROCESS_DETAIL) ;
    addActionListener(ShowDetailInstanceActionListener.class, SHOW_TASKS) ;   
    addActionListener(DeleteProcessActionListener.class, DELETE_PROCESS);
    addActionListener(DeleteProcessInstanceActionListener.class, DELETE_PROCESS_INSTANCE);
  }
  
  public Parameter[] getShowProcessesParams() { return SHOW_PROCESS_PARAMS ; }
  public Parameter[] getShowProcessDetailParams() { return SHOW_PROCESS_DETAIL_PARAMS ; }
  public Parameter[] getShowTasksParams() { return SHOW_TASKS_PARAMS ; }
  public Parameter[] getDeleteProcessParams() { return DELETE_PROCESS_PARAMS ; }
  public Parameter[] getDeleteProcessInstanceParams() { return DELETE_PROCESS_INSTANCE_PARAMS ; }
  
  public String getView() { return view_ ; }
  public List getProcesses() { return workflowServiceContainer_.getProcesses() ; }
  public List getProcessDetail() { return processDetail_ ;}
  public List getTasks() { return tasks_ ; }

  static public class ShowActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UIMonitor uicomp = (UIMonitor) event.getComponent() ;
      uicomp.view_ = SHOW_PROCESS;
    }
  }
    
  static public class ShowDetailActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UIMonitor uicomp = (UIMonitor) event.getComponent() ;
      String processDef = event.getParameter(OBJECTID) ;      
      uicomp.view_ = SHOW_PROCESS_DETAIL ;        
      uicomp.processDetail_ = uicomp.workflowServiceContainer_.getProcessInstances(processDef);
      uicomp.processDef_ = processDef;
    }
  }

  static public class ShowDetailInstanceActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UIMonitor uicomp = (UIMonitor) event.getComponent() ;
      uicomp.view_ = SHOW_TASKS;
      String instance = event.getParameter(OBJECTID) ; 
      uicomp.tasks_ = uicomp.workflowServiceContainer_.getTasks(instance);
    }
  }
  
  static public class DeleteProcessActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UIMonitor uicomp = (UIMonitor) event.getComponent() ;
      String processDef = event.getParameter(OBJECTID) ;
      uicomp.workflowServiceContainer_.deleteProcess(processDef);
    }
  }
  
  static public class DeleteProcessInstanceActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UIMonitor uicomp = (UIMonitor) event.getComponent() ;
      String instance = event.getParameter(OBJECTID) ;
      uicomp.workflowServiceContainer_.deleteProcessInstance(instance);
      uicomp.processDetail_ = uicomp.workflowServiceContainer_.getProcessInstances(uicomp.processDef_);
    }
  }
}
