package org.exoplatform.services.cms.drives;

import java.util.Iterator;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.Session;

import org.exoplatform.container.component.BaseComponentPlugin;
import org.exoplatform.container.xml.InitParams;
import org.exoplatform.container.xml.ObjectParameter;

public class ManageDrivePlugin extends BaseComponentPlugin {

  private static String WORKSPACE = "exo:workspace".intern() ;
  private static String PERMISSIONS = "exo:permissions".intern() ;
  private static String VIEWS = "exo:views".intern() ;
  private static String ICON = "exo:icon".intern() ;
  private static String PATH = "exo:path".intern() ;
  private static String FOLDER_TYPE = "exo:folderTypes".intern() ;
  private static String VIEW_REFERENCES = "exo:viewPreferences".intern() ;
  private static String VIEW_NON_DOCUMENT = "exo:viewNonDocument".intern() ;
  private static String VIEW_EXPLORER = "exo:viewExplorer".intern() ;
  private static String VIEW_CLIPBOARD = "exo:viewClipboard".intern() ;
  
  private InitParams params_ ; 
  
  public ManageDrivePlugin(InitParams params) throws Exception {        
    params_ = params ;        
  }

  protected void initPredefineDrives(Session session,String drivesPath) throws Exception {
    Iterator<ObjectParameter> it = params_.getObjectParamIterator() ;           
    Node driveHome = (Node)session.getItem(drivesPath) ;
    while(it.hasNext()){
      DriveData data = (DriveData)it.next().getObject() ;
      if(!driveHome.hasNode(data.getName())){
        Node driveNode = driveHome.addNode(data.getName(), "exo:drive");
        driveNode.setProperty(WORKSPACE, data.getWorkspace()) ;
        List<String> permissions = data.getPermissions() ;
        List<String> views = data.getViews() ;
        List<String> folderTypes = data.getFolderType() ;
        driveNode.setProperty(PERMISSIONS, permissions.<String>toArray(new String[permissions.size()])) ;
        driveNode.setProperty(PATH, data.getHomePath()) ;                
        driveNode.setProperty(FOLDER_TYPE,folderTypes.toArray(new String[folderTypes.size()])) ;
        driveNode.setProperty(VIEWS, views.<String>toArray(new String[views.size()])) ;
        driveNode.setProperty(ICON, data.getIcon()) ;
        driveNode.setProperty(VIEW_REFERENCES, data.getViewPreferences()) ;
        driveNode.setProperty(VIEW_NON_DOCUMENT, data.getViewNonDocument()) ;
        driveNode.setProperty(VIEW_EXPLORER, data.getViewExplorer()) ;
        driveNode.setProperty(VIEW_CLIPBOARD, data.getViewClipboard()) ;
        driveHome.save() ;
      }        
    }
    session.save() ;  
  }

}
