package org.exoplatform.services.workflow.impl.oncepi;

public interface WorkflowFileDefinitionService {

	 /**
	   * Remove a File Definition
	   * 
	   * @param processId identifies the File Definition to remove
	   */
	  public void remove(String processId);
	  
	  /**
	   * Retrieves a File Definition
	   * 
	   * @param  processId identifies the File Definition to retrieve
	   * @return the requested File Definition or <tt>null</tt> if not found
	   */
	  public FileDefinition retrieve(String processId);
	  
	  /**
	   * Stores a File Definition
	   * 
	   * @param fileDefinition the File Definition to store
	   * @param processId      identifies the File Definition to store
	   */
	  public void store(FileDefinition fileDefinition, String processId);
}
