/***************************************************************************
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

package org.exoplatform.services.webdav.commands.search;

import java.util.ArrayList;

import javax.jcr.RepositoryException;
import javax.jcr.query.InvalidQueryException;

import org.exoplatform.services.webdav.commands.WebDavCommand;
import org.exoplatform.services.webdav.request.documents.RequestDocument;
import org.exoplatform.services.webdav.request.documents.SearchRequestDoc;
import org.exoplatform.services.webdav.resource.searchable.SearchableResource;
import org.exoplatform.services.webdav.response.DavStatus;
import org.exoplatform.services.webdav.response.MultiStatus;
import org.exoplatform.services.webdav.response.Response;
import org.exoplatform.services.webdav.search.Search;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: SearchCommand.java 12304 2007-01-25 10:23:57Z gavrikvetal $
 */

public class SearchCommand extends WebDavCommand {
  
  protected boolean process() throws RepositoryException {
    RequestDocument requestDocument = davRequest().getDocumentFromRequest();
    
    if (!(requestDocument instanceof SearchRequestDoc)) {
      davResponse().setStatus(DavStatus.BAD_REQUEST);
      return false;
    }

    SearchableResource resource = getResourceFactory().getSearchableResource();
    
    Search search = ((SearchRequestDoc)requestDocument).getSearch();
    
    ArrayList<Response> responses = null;
    
    try {
      responses = resource.doSearch(search);
    } catch (InvalidQueryException qexc) {
      qexc.printStackTrace();      
      davResponse().setStatus(DavStatus.BAD_REQUEST);
      return false;
    }
    
    MultiStatus multistatus = new MultiStatus(responses);
    
    davResponse().setMultistatus(multistatus);      
    
    return true;    
  }
  
}
