package org.exoplatform.services.webdav.search.basicsearch.convertor;

/**
 * Created by The eXo Platform SARL
 * Author : Zagrebin Victor <zagrebin_v@mail.ru>
 * @version $Id: DynamicXSD.java 12004 2007-01-17 12:03:57Z geaz $
 */

public class DynamicXSD
{
  private String dasl_prefix_without_colon;
  public String dasl_prefix;
  public String xsd;

  /**
   * Dynamically creates a string with XSD shema to validate an XML
   * with DAV:searchrequest query.
   * The dynamic creation is necessary because of DASL prefix changing.
   *
   * @param dasl_prefix DASL prefix
   */
  DynamicXSD(String dasl_prefix)
  {
   this.dasl_prefix = dasl_prefix;
   dasl_prefix_without_colon = dasl_prefix.substring(0,dasl_prefix.length()-1);
   xsd = new String("")
       +  "<?xml version=\"1.0\" encoding=\"UTF-8\"?> \n\r"
       +  " <xsd:schema xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" \n\r"
       +  "             xmlns=\"http://www.w3.org/2001/\" \n\r"
       +  "             targetNamespace=\"DAV:/\" \n\r"
       +  "             xmlns:"+dasl_prefix_without_colon+"=\"DAV:/\" \n\r"
       +  "             elementFormDefault=\"qualified\" > \n\r"
       +  "   <xsd:element name=\"searchrequest\" type=\""+dasl_prefix+"BasicSearch\"/> \n\r"

       +  "   <xsd:complexType name=\"BasicSearch\"> \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:element name=\"basicsearch\" type=\""+dasl_prefix+"Options\"/> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "    <xsd:anyAttribute namespace=\"##any\"/> \n\r"
       +  "   </xsd:complexType> \n\r"

       +  "   <xsd:complexType name=\"Options\"> \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:group ref=\""+dasl_prefix+"SelectOptions\" minOccurs=\"1\" maxOccurs=\"1\" /> \n\r"
       +  "     <xsd:group ref=\""+dasl_prefix+"FromOptions\" minOccurs=\"1\" maxOccurs=\"1\" /> \n\r"
       +  "     <xsd:group ref=\""+dasl_prefix+"WhereOptions\" minOccurs=\"0\" maxOccurs=\"1\" /> \n\r"
       +  "     <xsd:group ref=\""+dasl_prefix+"OrderbyOptions\" minOccurs=\"0\" maxOccurs=\"1\" /> \n\r"
       +  "     <xsd:group ref=\""+dasl_prefix+"LimitOptions\" minOccurs=\"0\" maxOccurs=\"1\" /> \n\r"
       +  "    </xsd:sequence>  \n\r"
       +  "   </xsd:complexType>  \n\r"

       +  "   <xsd:group name=\"SelectOptions\">  \n\r"
       +  "    <xsd:sequence>  \n\r"
       +  "     <xsd:element name=\"select\" type=\""+dasl_prefix+"SelectOption\" minOccurs=\"1\" maxOccurs=\"1\"/> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "   </xsd:group> \n\r"

       +  "   <xsd:complexType name=\"SelectOption\">  \n\r"
       +  "    <xsd:choice> \n\r"
       +  "     <xsd:element ref=\""+dasl_prefix+"prop\" minOccurs=\"1\" maxOccurs=\"1\"/> \n\r"
       +  "     <xsd:element ref=\""+dasl_prefix+"allprop\" minOccurs=\"1\" maxOccurs=\"1\"/> \n\r"
       +  "    </xsd:choice> \n\r"
       +  "   </xsd:complexType>  \n\r"

       +  "   <xsd:group name=\"FromOptions\">  \n\r"
       +  "    <xsd:sequence>  \n\r"
       +  "     <xsd:element name=\"from\" type=\""+dasl_prefix+"FromOption\" minOccurs=\"1\" maxOccurs=\"1\"/> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "   </xsd:group> \n\r"

       +  "   <xsd:complexType name=\"FromOption\">  \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:element name=\"scope\" type=\""+dasl_prefix+"ScopeOption\" minOccurs=\"1\" maxOccurs=\"unbounded\"/> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "   </xsd:complexType>  \n\r"

       +  "   <xsd:group name=\"WhereOptions\">  \n\r"
       +  "    <xsd:sequence>  \n\r"
       +  "     <xsd:element name=\"where\" type=\""+dasl_prefix+"NotOption\" minOccurs=\"0\" maxOccurs=\"1\"/> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "   </xsd:group> \n\r"

       +  "   <xsd:complexType name=\"ScopeOption\">  \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:element ref=\""+dasl_prefix+"href\" minOccurs=\"1\" maxOccurs=\"1\" /> \n\r"
       +  "     <xsd:element ref=\""+dasl_prefix+"depth\" minOccurs=\"1\" maxOccurs=\"1\" /> \n\r"
       +  "     <xsd:element name=\"include-versions\" type=\""+dasl_prefix+"IncludeVersionOption\" minOccurs=\"0\" maxOccurs=\"1\" /> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "   </xsd:complexType>  \n\r"

       +  "   <xsd:complexType name=\"IncludeVersionOption\">  \n\r"
       +  "    <xsd:sequence>\n\r"
       +  "     <xsd:element name=\"include-version\" > \n\r"
       +  "      <xsd:complexType/> \n\r"
       +  "     </xsd:element> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "   </xsd:complexType> \n\r"

       +  "   <xsd:group name=\"OrderbyOptions\">  \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:element name=\"orderby\" type=\""+dasl_prefix+"OrderbyOption\" minOccurs=\"0\" maxOccurs=\"1\"/> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "   </xsd:group> \n\r"
       +  "   <xsd:complexType name=\"OrderbyOption\">  \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:element name=\"order\" type=\""+dasl_prefix+"OrderOptions\" minOccurs=\"1\" maxOccurs=\"unbounded\"/> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "   </xsd:complexType>  \n\r"
       +  "   <xsd:complexType name=\"OrderOptions\">  \n\r"
       +  "    <xsd:sequence>  \n\r"
       +  "     <xsd:choice>  \n\r"
       +  "      <xsd:element ref=\""+dasl_prefix+"prop\" minOccurs=\"1\" maxOccurs=\"1\" /> \n\r"
       +  "      <xsd:element ref=\""+dasl_prefix+"score\" minOccurs=\"1\" maxOccurs=\"1\" /> \n\r"
       +  "     </xsd:choice>  \n\r"
       +  "     <xsd:choice minOccurs=\"0\" maxOccurs=\"1\">  \n\r"
       +  "      <xsd:element ref=\""+dasl_prefix+"ascending\" minOccurs=\"1\" maxOccurs=\"1\" /> \n\r"
       +  "      <xsd:element ref=\""+dasl_prefix+"descending\" minOccurs=\"1\" maxOccurs=\"1\" /> \n\r"
       +  "     </xsd:choice> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "    <xsd:attribute name=\"caseless\" type=\""+dasl_prefix+"Binary\" use=\"optional\" /> \n\r"
       +  "   </xsd:complexType> \n\r"
       +  "   <xsd:group name=\"LimitOptions\"> \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:element name=\"limit\" type=\""+dasl_prefix+"LimitOption\" minOccurs=\"0\" maxOccurs=\"1\"/> \n\r"
       +  "    </xsd:sequence>  \n\r"
       +  "   </xsd:group>  \n\r"
       +  "   <xsd:complexType name=\"LimitOption\">  \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:element ref=\""+dasl_prefix+"nresults\" minOccurs=\"1\" maxOccurs=\"1\"/> \n\r"
       +  "    </xsd:sequence>  \n\r"
       +  "   </xsd:complexType>  \n\r"
       +  "   <xsd:group name=\"AllOptions\">  \n\r"
       +  "    <xsd:choice> \n\r"
       +  "     <xsd:group ref=\""+dasl_prefix+"StringOptions\" minOccurs=\"1\" maxOccurs=\"1\"/> \n\r"
       +  "     <xsd:group ref=\""+dasl_prefix+"CompareOptions\" minOccurs=\"1\" maxOccurs=\"1\"/> \n\r"
       +  "     <xsd:group ref=\""+dasl_prefix+"LogicalOptions\" minOccurs=\"1\" maxOccurs=\"1\"/> \n\r"
       +  "     <xsd:group ref=\""+dasl_prefix+"ContainsOptions\" minOccurs=\"1\" maxOccurs=\"1\"/> \n\r"
       +  "     <xsd:group ref=\""+dasl_prefix+"SpecialOptions\" minOccurs=\"1\" maxOccurs=\"1\"/> \n\r"
       +  "    </xsd:choice> \n\r"
       +  "   </xsd:group> \n\r"
       +  "   <xsd:group name=\"LogicalOptions\">  \n\r"
       +  "    <xsd:choice>\n\r"
       +  "     <xsd:element name=\"and\" type=\""+dasl_prefix+"OrOption\" minOccurs=\"1\" maxOccurs=\"1\"/> \n\r"
       +  "     <xsd:element name=\"or\" type=\""+dasl_prefix+"OrOption\" minOccurs=\"1\" maxOccurs=\"1\"/> \n\r"
       +  "     <xsd:element name=\"not\" type=\""+dasl_prefix+"NotOption\" minOccurs=\"1\" maxOccurs=\"1\"/> \n\r"
       +  "    </xsd:choice> \n\r"
       +  "   </xsd:group>  \n\r"
       +  "   <xsd:complexType name=\"OrOption\">  \n\r"
       +  "    <xsd:group ref=\""+dasl_prefix+"AllOptions\" minOccurs=\"1\" maxOccurs=\"unbounded\"/> \n\r"
       +  "   </xsd:complexType>  \n\r"
       +  "   <xsd:complexType name=\"NotOption\">  \n\r"
       +  "     <xsd:group ref=\""+dasl_prefix+"AllOptions\" minOccurs=\"1\" maxOccurs=\"1\"/> \n\r"
       +  "   </xsd:complexType>  \n\r"
       +  "   <xsd:group name=\"StringOptions\">  \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:element name=\"like\" type=\""+dasl_prefix+"LikeOption\"/> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "   </xsd:group> \n\r"
       +  "   <xsd:group name=\"SpecialOptions\">  \n\r"
       +  "    <xsd:choice> \n\r"
       +  "     <xsd:element name=\"is-collection\" > \n\r"
       +  "      <xsd:complexType/> \n\r"
       +  "     </xsd:element> \n\r"
       +  "     <xsd:element name=\"is-defined\" type=\""+dasl_prefix+"LanguageDefinedOption\" /> \n\r"
       +  "     <xsd:element name=\"language-defined\" type=\""+dasl_prefix+"LanguageDefinedOption\"/> \n\r"
       +  "     <xsd:element name=\"language-matches\" type=\""+dasl_prefix+"LanguageMatchesOption\"/> \n\r"
       +  "    </xsd:choice> \n\r"
       +  "   </xsd:group>  \n\r"
       +  "   <xsd:group name=\"ContainsOptions\">  \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:element ref=\""+dasl_prefix+"contains\" /> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "   </xsd:group>  \n\r"
       +  "   <xsd:group name=\"CompareOptions\">  \n\r"
       +  "    <xsd:choice> \n\r"
       +  "     <xsd:element name=\"eq\" type=\""+dasl_prefix+"CompareOption\" minOccurs=\"0\" /> \n\r"
       +  "     <xsd:element name=\"lt\" type=\""+dasl_prefix+"CompareOption\" minOccurs=\"0\" /> \n\r"
       +  "     <xsd:element name=\"lte\" type=\""+dasl_prefix+"CompareOption\" minOccurs=\"0\" /> \n\r"
       +  "     <xsd:element name=\"gt\" type=\""+dasl_prefix+"CompareOption\" minOccurs=\"0\" /> \n\r"
       +  "     <xsd:element name=\"gte\" type=\""+dasl_prefix+"CompareOption\" minOccurs=\"0\" /> \n\r"
       +  "    </xsd:choice> \n\r"
       +  "   </xsd:group> \n\r"
       +  "   <xsd:complexType name=\"CompareOption\">  \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:element ref=\""+dasl_prefix+"prop\" minOccurs=\"1\" /> \n\r"
       +  "      <xsd:choice> \n\r"
       +  "       <xsd:element ref=\""+dasl_prefix+"literal\" minOccurs=\"1\" maxOccurs=\"1\" /> \n\r"
       +  "       <xsd:group ref=\""+dasl_prefix+"TypedLiteral\" minOccurs=\"1\" maxOccurs=\"1\" />\n\r"
       +  "      </xsd:choice> \n\r"
       +  "    </xsd:sequence>\n\r"
       +  "    <xsd:attribute name=\"caseless\" type=\""+dasl_prefix+"Binary\" use=\"optional\" /> \n\r"
       +  "   </xsd:complexType>  \n\r"
       +  "   <xsd:complexType name=\"LanguageDefinedOption\">  \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:element ref=\""+dasl_prefix+"prop\" minOccurs=\"1\" /> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "   </xsd:complexType>  \n\r"
       +  "   <xsd:complexType name=\"LanguageMatchesOption\">  \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:element ref=\""+dasl_prefix+"prop\" minOccurs=\"1\" /> \n\r"
       +  "     <xsd:element ref=\""+dasl_prefix+"literal\" minOccurs=\"1\" /> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "   </xsd:complexType>  \n\r"
       +  "   <xsd:complexType name=\"LikeOption\">  \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:element ref=\""+dasl_prefix+"prop\" minOccurs=\"1\" /> \n\r"
       +  "     <xsd:element ref=\""+dasl_prefix+"literal\" minOccurs=\"1\" /> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "    <xsd:attribute name=\"caseless\" type=\""+dasl_prefix+"Binary\" use=\"optional\" /> \n\r"
       +  "   </xsd:complexType>  \n\r"
       +  "   <xsd:complexType name=\"Prop\" mixed=\"true\">  \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:any namespace=\"##any\" minOccurs=\"0\" maxOccurs=\"unbounded\" processContents=\"skip\"/> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "   </xsd:complexType>  \n\r"
       +  "   <xsd:simpleType name=\"Binary\">  \n\r"
       +  "    <xsd:restriction base=\"xsd:string\"> \n\r"
       +  "     <xsd:enumeration value=\"yes\" /> \n\r"
       +  "     <xsd:enumeration value=\"no\" /> \n\r"
       +  "    </xsd:restriction> \n\r"
       +  "   </xsd:simpleType>  \n\r"
       +  "   <xsd:group name=\"TypedLiteral\">  \n\r"
       +  "    <xsd:sequence> \n\r"
       +  "     <xsd:element name=\"typed-literal\" minOccurs=\"1\"> \n\r"
       +  "      <xsd:complexType> \n\r"
       +  "        <xsd:attribute name=\"data\"> \n\r"
       +  "         <xsd:simpleType> \n\r"
       +  "          <xsd:restriction base=\"xsd:string\"/> \n\r"
       +  "         </xsd:simpleType> \n\r"
       +  "        </xsd:attribute> \n\r"
       +  "      </xsd:complexType> \n\r"
       +  "     </xsd:element> \n\r"
       +  "    </xsd:sequence> \n\r"
       +  "   </xsd:group>  \n\r"
       +  "   <xsd:element name=\"href\" type=\"xsd:string\"/>  \n\r"
       +  "   <xsd:element name=\"depth\" type=\"xsd:string\"/>  \n\r"
       +  "   <xsd:element name=\"contains\" type=\"xsd:string\"/>  \n\r"
       +  "   <xsd:element name=\"prop\" type=\""+dasl_prefix+"Prop\" />  \n\r"
       +  "   <xsd:element name=\"literal\" type=\"xsd:string\" />  \n\r"
       +  "   <xsd:element name=\"score\" type=\"xsd:string\"/>  \n\r"
       +  "   <xsd:element name=\"nresults\" type=\"xsd:string\"/>  \n\r"
       +  "   <xsd:element name=\"allprop\" >  \n\r"
       +  "    <xsd:complexType/> \n\r"
       +  "   </xsd:element>  \n\r"
       +  "   <xsd:element name=\"ascending\" >  \n\r"
       +  "    <xsd:complexType/> \n\r"
       +  "   </xsd:element>  \n\r"
       +  "   <xsd:element name=\"descending\" >  \n\r"
       +  "    <xsd:complexType/> \n\r"
       +  "   </xsd:element>  \n\r"
       +  "  </xsd:schema> \n\r";
  }
}





