/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: InstallEvent.java 8877 2006-09-14 13:51:24Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applet.install.event;

import java.util.EventObject;

/**
 * @version $Rev: 8877 $ $Date: 2006-09-14 20:51:24 +0700 (Thu, 14 Sep 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public class InstallEvent extends EventObject {

	public static final int INSTALL_BEGIN = 1;
	public static final int INSTALL_END = 2;

	public static final int DOWNLOAD_START = 3;
	public static final int DOWNLOAD_PROGRESS = 4;
	public static final int DOWNLOAD_COMPLETE = 5;
	public static final int DOWNLOAD_FAILURE = 6;

	public static final int LOAD_START = 7;
	public static final int LOAD_LIBRARIES = 8;
	public static final int LOAD_APPLET = 9;
	public static final int LOAD_PLUGIN = 10;
	public static final int LOAD_FAILURE = 11;
	public static final int LOAD_COMPLETE = 12;

    private static final long serialVersionUID = 1L;

    private int action;

	/**
     * @param source
     */
    public InstallEvent(Object source, int action) {
	    super(source);
	    this.action = action;
    }

	/**
     * @return the type
     */
    public int getAction() {
    	return action;
    }

}
