/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: AppletParamHelper.java 10464 2006-11-21 18:55:33Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applet.launcher;

import java.applet.Applet;

import org.exoplatform.applet.ParamHelper;

/**
 * @version $Rev: 10464 $ $Date: 2006-11-22 01:55:33 +0700 (Wed, 22 Nov 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public class AppletParamHelper implements ParamHelper {

	public static final String APPLET_CONFIG_PARAM_NAME = "launcherConfiguration";
	public static final String CODE_BASE_URL_PARAM_NAME = "codeBaseUrl";
	public static final String LOGGING_LEVEL_PARAM_NAME = "loggingLevel";

	private String[][] parameterInfo = null;

	private Applet applet;

	/**
     * @param applet
     */
    public AppletParamHelper(Applet applet) {
	    super();
	    this.applet = applet;
    }

	public String getLauncherConfigurationParam() {
		return getParameter(APPLET_CONFIG_PARAM_NAME);
	}

	public String getCodeBaseUrlParam() {
		return getParameter(CODE_BASE_URL_PARAM_NAME);
	}

    public String getLoggingLevelParam() {
	    return getParameter(LOGGING_LEVEL_PARAM_NAME);
    }

	/* (non-Javadoc)
	 * @see org.exoplatform.applet.ParamHelper#getParameter(java.lang.String)
	 */
	public String getParameter(String name) {
	    return applet.getParameter(name);
	}

	/* (non-Javadoc)
	 * @see org.exoplatform.applet.ParamHelper#getParameterInfo()
	 */
	public String[][] getParameterInfo() {
		if (parameterInfo == null) {
			parameterInfo = new String[][] {
					{APPLET_CONFIG_PARAM_NAME,"base64", "org.exoplatform.applet.deploy.LauncherConfiguration encoded object"},
					{CODE_BASE_URL_PARAM_NAME, "url", "Download code base location to retrieve referenced components"},
					{LOGGING_LEVEL_PARAM_NAME, "text", "Check declared Level types."}
			};
		}
		return parameterInfo;
	}

}
