/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: DelegationAppletStub.java 8877 2006-09-14 13:51:24Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applet.launcher;

import java.applet.Applet;
import java.applet.AppletContext;
import java.applet.AppletStub;
import java.net.URL;

/**
 * @version $Rev: 8877 $ $Date: 2006-09-14 20:51:24 +0700 (Thu, 14 Sep 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public class DelegationAppletStub implements AppletStub {

	private Applet delegate;

	/**
     * @param applet
     */
    public DelegationAppletStub(Applet applet) {
	    super();
	    this.delegate = applet;
    }

	/* (non-Javadoc)
	 * @see java.applet.AppletStub#appletResize(int, int)
	 */
	public void appletResize(int width, int height) {
		delegate.resize(width, height);
	}

	/* (non-Javadoc)
	 * @see java.applet.AppletStub#getAppletContext()
	 */
	public AppletContext getAppletContext() {
		return delegate.getAppletContext();
	}

	/* (non-Javadoc)
	 * @see java.applet.AppletStub#getCodeBase()
	 */
	public URL getCodeBase() {
		return delegate.getCodeBase();
	}

	/* (non-Javadoc)
	 * @see java.applet.AppletStub#getDocumentBase()
	 */
	public URL getDocumentBase() {
		return delegate.getDocumentBase();
	}

	/* (non-Javadoc)
	 * @see java.applet.AppletStub#getParameter(java.lang.String)
	 */
	public String getParameter(String name) {
		return delegate.getParameter(name);
	}

	/* (non-Javadoc)
	 * @see java.applet.AppletStub#isActive()
	 */
	public boolean isActive() {
		return delegate.isActive();
	}

}
