/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: LogRecord.java 8955 2006-09-18 13:46:06Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applet.logging;

import java.io.Serializable;
import java.util.ResourceBundle;

/**
 * @version $Rev: 8955 $ $Date: 2006-09-18 20:46:06 +0700 (Mon, 18 Sep 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public class LogRecord implements Serializable {

    private static final long serialVersionUID = 1L;

    private static long sequenceCounter = 0;

    private Level level;
    private String loggerName;
    private String message;
    private long millis;
    private Object[] parameters;
    private ResourceBundle resourceBundle;
    private String resourceBundleName;
    private long sequenceNumber;
    private String sourceClassName;
    private String sourceMethodName;
    private int threadID;
    private Throwable thrown;

    public LogRecord(Level level, String msg) {
	    super();
	    setLevel(level);
	    setMessage(msg);
	    setSequenceNumber(++sequenceCounter);
    }

	public Level getLevel() {
    	return level;
    }

	public void setLevel(Level level) {
    	this.level = level;
    }

	public String getLoggerName() {
    	return loggerName;
    }

	public void setLoggerName(String loggerName) {
    	this.loggerName = loggerName;
    }

	public String getMessage() {
    	return message;
    }

	public void setMessage(String message) {
    	this.message = message;
    }

	public long getMillis() {
    	return millis;
    }

	public void setMillis(long millis) {
    	this.millis = millis;
    }

	public Object[] getParameters() {
    	return parameters;
    }

	public void setParameters(Object[] parameters) {
    	this.parameters = parameters;
    }

	public ResourceBundle getResourceBundle() {
    	return resourceBundle;
    }

	public void setResourceBundle(ResourceBundle resourceBundle) {
    	this.resourceBundle = resourceBundle;
    }

	public String getResourceBundleName() {
    	return resourceBundleName;
    }

	public void setResourceBundleName(String resourceBundleName) {
    	this.resourceBundleName = resourceBundleName;
    }

	public long getSequenceNumber() {
    	return sequenceNumber;
    }

	public void setSequenceNumber(long sequenceNumber) {
    	this.sequenceNumber = sequenceNumber;
    }

	public String getSourceClassName() {
    	return sourceClassName;
    }

	public void setSourceClassName(String sourceClassName) {
    	this.sourceClassName = sourceClassName;
    }

	public String getSourceMethodName() {
    	return sourceMethodName;
    }

	public void setSourceMethodName(String sourceMethodName) {
    	this.sourceMethodName = sourceMethodName;
    }

	public int getThreadID() {
    	return threadID;
    }

	public void setThreadID(int threadID) {
    	this.threadID = threadID;
    }

	public Throwable getThrown() {
    	return thrown;
    }

	public void setThrown(Throwable thrown) {
    	this.thrown = thrown;
    }

    
}
