/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: JavaScriptBrowser.java 9990 2006-11-01 19:21:46Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applet.scripting;

import java.applet.Applet;

/**
 * This class includes JavaScriptObject functionalities provided by applet
 * plugins within browsers compatible only with JVM 1.3 or later.
 *
 * @version $Rev: 9990 $ $Date: 2006-11-02 02:21:46 +0700 (Thu, 02 Nov 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public class JavaScriptBrowser implements ScriptingBrowser {

	private static final String FIELD_VALUE_MEMBER_NAME = "value";

	private Applet applet;

	private ScriptingObject window;

	private ScriptingObject document;

    public JavaScriptBrowser(Applet applet) {
	    super();
	    this.applet = applet;
    }

    /* (non-Javadoc)
     * @see org.exoplatform.applet.scripting.ScriptingBrowser#getWindow()
     */
    public ScriptingObject getWindow() {
    	if (window == null) {
    		window = JavaScriptObject.getWindow(applet);
    	}
    	return window;
    }

    /* (non-Javadoc)
     * @see org.exoplatform.applet.scripting.ScriptingBrowser#getDocument()
     */
    public ScriptingObject getDocument() {
    	if (document == null) {
    		document = (ScriptingObject) getWindow().getMember("document");
    	}
    	return document;
    }

    /* (non-Javadoc)
     * @see org.exoplatform.applet.scripting.ScriptingBrowser#getForm(java.lang.String)
     */
    public ScriptingObject getForm(String formName) {
//	    Object form = getDocument().getMember(formName);
    	Object form = getWindow().eval("document.getElementById('" + formName + "')");
    	return (form == null ? null : (ScriptingObject) form);
    }

    public String getMemberValue(Object member) {
    	String value = null;

    	if (member instanceof ScriptingObject) {
    		ScriptingObject obj = (ScriptingObject) member;
    		value = (String) obj.getMember(FIELD_VALUE_MEMBER_NAME);
    	}

    	return value;
    }

    public void setMemberValue(Object member, Object value) {
    	if (member instanceof ScriptingObject) {
    		ScriptingObject obj = (ScriptingObject) member;
    		obj.setMember(FIELD_VALUE_MEMBER_NAME, value);
    	}
    }
}
