/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: ExoAppletUtils.java 8955 2006-09-18 13:46:06Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applet.util;

import java.applet.Applet;
import java.net.URL;

import org.exoplatform.applet.logging.Logger;
import org.exoplatform.applet.logging.LoggingSupport;
import org.exoplatform.applet.logging.file.FileLoggerFactory;

/**
 * @version $Rev: 8955 $ $Date: 2006-09-18 20:46:06 +0700 (Mon, 18 Sep 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public class ExoAppletUtils {

	private static Logger logger;

	static {
		LoggingSupport factory = FileLoggerFactory.getInstance();
		logger = factory.getLogger(ExoAppletUtils.class.getName());
	}

	/**
     * @param applet
     * @return
     */
    public static String getCodeBase(Applet applet) {

    	logger.entering("ExoAppletUtils", "getCodeBase", applet);

    	URL codeBase = applet.getCodeBase();

        String surl = codeBase.getProtocol() + "://" + codeBase.getHost();

        if (("http".equalsIgnoreCase(codeBase.getProtocol())
                && codeBase.getPort() != 80
                && codeBase.getPort() != -1)
                || ("https".equalsIgnoreCase(codeBase.getProtocol())
                && codeBase.getPort() != 443
                && codeBase.getPort() != -1)) {
            surl = surl + ":";
            surl = surl + codeBase.getPort();
        }

        logger.exiting("ExoAppletUtils", "getCodeBase", surl);

        return surl;
    }

}
