/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: EmbeddingStrategyFactory.java 10468 2006-11-22 00:20:32Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.services.appletconfig.impl.embed;

import org.exoplatform.services.appletconfig.BrowserDetect;

/**
 * @version $Rev: 10468 $ $Date: 2006-11-22 07:20:32 +0700 (Wed, 22 Nov 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public class EmbeddingStrategyFactory {

    /**
     * 
     */
    private EmbeddingStrategyFactory() {
        super();
    }

    /**
     * @param ua
     * @return
     */
    public static EmbeddingStrategy getInstance(BrowserDetect ua) {

        EmbeddingStrategy instance = null;

        if (ua.isIE() || ua.isIECompatible())
            instance = new ObjectTagAppletEmbedding();
        else if (ua.isMozilla() || ua.isNS() || ua.isNSCompatible())
            instance = new EmbedTagAppletEmbedding();
        else
            instance = new MixedAppletEmbedding();

        return instance;
    }

}
