/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.grammar.wiki.impl;

import java.util.Map;

import org.exoplatform.container.xml.InitParams;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Dec 19, 2004
 * @version $Id: SmileyTokenHandler.java 5799 2006-05-28 17:55:42Z geaz $
 */
public class SmileyTokenHandler extends TokenHandler {
 
  private Map smileys_ ;
  
  public SmileyTokenHandler() throws Exception {
  }
  
  public void  init(InitParams params) {
    smileys_ = params.getPropertiesParam("smiley.configuration").getProperties();
  }
 
  public Token handleToken(Token parent, Token token, ParsingContext context)  {
    String timage = token.getTokenImage(context) ;
    String image = (String) smileys_.get(timage) ;
    if(image == null)  context.getOutputBuffer().append(timage) ;
    else  context.getOutputBuffer().append(image) ;
    return context.nextToken(token) ;
  }
  
  public String[] getHandleableTokenType() { return new String[] { Token.SMILEY_TOKEN}  ;}
}