/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.grammar.wiki.impl;

import org.apache.commons.pool.BasePoolableObjectFactory;
import org.apache.commons.pool.ObjectPool;
import org.apache.commons.pool.impl.StackObjectPool;
import org.exoplatform.commons.utils.ExceptionUtil;
import org.exoplatform.container.xml.InitParams;
import org.exoplatform.services.grammar.wiki.WikiContext;
import org.exoplatform.services.grammar.wiki.WikiEngineService;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Dec 17, 2004
 * @version $Id: WikiEngineServiceImpl.java 5799 2006-05-28 17:55:42Z geaz $
 */
public class WikiEngineServiceImpl implements WikiEngineService {
  private ObjectPool pool;
  /*
  public WikiEngineServiceImpl(ConfigurationManager manager) throws Exception {
    ServiceConfiguration sconf = manager.getServiceConfiguration(WikiEngineService.class) ;
    pool = new StackObjectPool(new ParsingContextFactory(sconf)) ;
    
  }
  */
  public WikiEngineServiceImpl(InitParams params) throws Exception {
    pool = new StackObjectPool(new ParsingContextFactory(params)) ;  
  } 
  
  public String toXHTML(String text) {
    return toXHTML(text, null) ;
  }
  
  public String toXHTML(String wiki, WikiContext context) {
    ParsingContext parsingContext = null ;
    String result = null ;
    try {
      parsingContext = (ParsingContext) pool.borrowObject() ;
      parsingContext.setWikiContext(context) ;
      parsingContext.transform(wiki) ;
      result = parsingContext.getOutputBuffer().toString() ;
    } catch (Exception ex) {
      result = wiki + "<br/><br/>=========-CANNOT CONVERT WIKI TO HTML===========<br/>"  +
               ExceptionUtil.getStackTrace(ex, 15) ;
    }
    return result;
  }
  
  static class ParsingContextFactory extends BasePoolableObjectFactory {  
    InitParams params_ ;
    
    ParsingContextFactory(InitParams params) {
      params_ =  params ;
    }
    
    public Object makeObject() { 
      return new ParsingContext(params_); 
    } 
    
    public void passivateObject(Object obj) {  
    }  
  } 
}
