/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.ticket;

import java.util.Date;

/**
 * Created by The eXo Platform SARL
 * Author : Chung Nguyen
 *          nguyenchung136@yahoo.com
 * Jan 5, 2006
 * 
 * This class is used  to control the security of  a task or a resource. 
 */
public interface Ticket {
  static final  public int UNLIMITED_ACCESS =  -1 ;
  
  static final  public int VALID_STATUS =  0 ;
  static final  public int EXPIRED_STATUS =  1 ;
  static final  public int LOCKED_STATUS =  2 ;
  
  public String getId() ;
  
  public int  getAccessCounter() ;
  
  public int  getLimitAccess() ;
  
  public String getCreator() ;
  
  public Date getCreationTime() ;
  
  public String getLastAccessUser() ;
  
  public Date getLastAccessTime() ;
  
  public long getLiveTime() ;
  
  public String[] getAlowUsers();
  
  public String[] getRequiredPermissions();
  
  public int getStatus() ;
}

