/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.ticket;

/**
 * Created by The eXo Platform SARL
 * Author : Chung Nguyen
 *          chungnv@users.sourceforge.net
 * Jan 5, 2006
 * 
 * This service is used to manage the  the ticket , a ticket is an instance of a security control
 * for a task or a resource. A ticket 
 */
public interface TicketService {
  
  public String createTicket(long liveTime , int limitAccess,String desc, String owenCreator,
                             String[] allowedUser, String[] requiredPermissions, 
                             TicketCommand command) throws Exception ;
  
  public String createTicket(long liveTime , int limitAccess,String desc,TicketCommand command) throws Exception ;
  
  public Ticket  getTicket(String id) throws Exception ;  
  public Ticket  getTicket(String id, String accessUser) throws Exception ;
  
  public Object  executeTicketCommand(String ticketId) throws Exception ;  
  public Object  executeTicketCommand(Ticket ticket) throws Exception ;  
  public Object  executeTicketCommand(String ticketId, String accessUser) throws Exception ;  
  public Object  executeTicketCommand(Ticket ticket, String accessUser) throws Exception ;
  
  public void removeTicket(String id) throws Exception;
}