/*
 * Created on Mar 15, 2005
 */
package org.exoplatform.faces.core.component;

import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.faces.context.FacesContext;
import javax.faces.event.PhaseId;
import javax.portlet.PortletRequest;
import javax.servlet.http.HttpServletRequest;

import org.apache.commons.fileupload.DiskFileUpload;
import org.apache.commons.fileupload.FileItem;
import org.exoplatform.faces.FacesConstants;
import org.exoplatform.faces.core.Util;
import org.exoplatform.faces.core.event.ExoActionEvent;

/**
 * @author benjaminmestrallet
 */
public class UISimpleMulltipartForm extends UISimpleForm {

  final public static String SIMPLE_MULTIPART_FORM_RENDERER = "SimpleMultipartFormRenderer";

  public UISimpleMulltipartForm(String name, String method, String formId) {
    super(name, method, formId);
    setRendererType(SIMPLE_MULTIPART_FORM_RENDERER);
  }

  public void processDecodes(FacesContext context) {
    error_ = false;
    Map paramMap = context.getExternalContext().getRequestParameterMap();
    String uicomponent = (String) paramMap.get(UICOMPONENT);
    
    if (!getId().equals(uicomponent))
      return;
    PortletRequest request = (PortletRequest) context.getExternalContext().getRequest();
    HttpServletRequest httpRequest = (HttpServletRequest) request;
    DiskFileUpload upload = new DiskFileUpload();
    String action = "";
    try {
      List items = upload.parseRequest(httpRequest);
      Set inputNames = getUIInputs().keySet();
      for (Iterator iter = inputNames.iterator(); iter.hasNext();) {
        String inputName = (String) iter.next();
        UIInput input = getUIInput(inputName);
        input.decodeFromMultipartFields(context, this, items);
      }
      for (Iterator iter = items.iterator(); iter.hasNext();) {
        FileItem item = (FileItem) iter.next();
        if(item.isFormField()) {
          String name = item.getFieldName();
          if(FacesConstants.ACTION.equals(name))
            action = item.getString();
        }
      }    
      setUserAction(action);   
      ExoActionEvent event =new ExoActionEvent(this, action, paramMap);
       if(Util.getActionPhaseId(action) == PhaseId.APPLY_REQUEST_VALUES) {
        broadcast(event) ;
      } else {
        queueEvent(event) ;
      }    
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

}