/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.core.component;

import java.util.* ;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator ;


public class UITimeInput extends UIInput {
  public static final String  COMPONENT_FAMILY = "org.exoplatform.faces.core.component.UITimeInput" ;

  protected GregorianCalendar calendar_ ;
  protected int minuteStep_;

  public UITimeInput(String name, Date date) {
  	setId(name) ;
    name_ = name ;
    calendar_ = new GregorianCalendar() ;
    calendar_.setTime(date);
    minuteStep_ = 1;
    editable_ = true ;
    setRendererType("TimeInputRenderer") ;
  }    

  public UITimeInput(String name, Date date, int minuteStep) {
  	this(name, date);
    minuteStep_ = minuteStep;
  }
  
  public String getFamily() {  return COMPONENT_FAMILY ; }
    
  public Object getDecodedValue() { return calendar_.getTime() ; }
  
  public Calendar getCalendar() { return calendar_ ; }
  
  public UITimeInput addValidator(Validator validator) {
    addComponentValidator(validator) ;
    return this ;
  }
  
  public UITimeInput addValidator(Class clazz) {
    addComponentValidator(clazz) ;
    return this ;
  }
  
  public UITimeInput addTime(Date date) {
    calendar_.setTime(date);
    return this ;
  }

  public void setMinuteStep_(int minuteStep) {
	minuteStep_ = minuteStep;
  }

  public int getMinuteStep_() {
	return minuteStep_;
  }

  final public  void processValidators(FacesContext context) {
    processValidators(context, calendar_) ;
  }
}