/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.core.validator;

import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.Util;
import org.exoplatform.faces.core.component.UIInput;
/**
 * @author Dung Hoang (jobdung@yahoo.com)
 * @since Dec 16, 2005
 * @version $Id: NameValidator.java,v 1.4 2005/12/16 14:53:44 jobdung Exp $
 */
public class NameValidator implements Validator {
  public void validate(FacesContext context, 
                       UIComponent component, 
                       Object value) throws ValidatorException {
    ResourceBundle res =  Util.getApplicationResourceBundle()  ;
    String s = (String) value ;
    if(s == null || s.length() == 0) {
      UIInput uiInput = (UIInput) component ;
      Object[] args = {uiInput.getName()} ;
      
      throw new ValidatorException(new ExoFacesMessage(res.getString("IdentifierValidator.msg.empty-input"), args)) ;
    }
    for(int i = 0; i < s.length() ; i++) {
      char c = s.charAt(i) ;      
      if(Character.isLetter(c) || Character.isDigit(c) || c =='_'|| c =='-'|| c =='.' || c == '*') {
        continue ;
      }
      UIInput uiInput = (UIInput) component ;
      Object[] args = {uiInput.getName()} ;
      throw new ValidatorException(new ExoFacesMessage(res.getString("IdentifierValidator.msg.invalid-char"), args)) ;
    }
  }
}	