/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.search.component;

import java.util.ArrayList;
import java.util.List;

import org.exoplatform.faces.core.component.ComponentTemplate;
import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 27, 2004
 * @version $Id: UISearchBar.java,v 1.2 2004/10/30 02:29:51 tuan08 Exp $
 */
public class UISearchBar extends UISimpleForm implements ComponentTemplate {
  static final public String SEARCH_ACTION = "search" ;
  static final public String ADVANCED_SEARCH_ACTION = "advancedSearch" ;
  static String TERM = "term", SEARCH_FIELD = "searchField" ;

  UIStringInput termInput_ ;
  UISelectBox   searchFieldInput_;
  List searchOptions_ ;
  String template_ = "org/exoplatform/faces/search/renderer/html/UISearchBar.vm" ;

  public UISearchBar() {
    super("quickSearchForm", "post", null) ;
          setId("UISearchBar") ;
    setClazz("UISearchBar");
    setRendererType("SimpleFormVelocityRenderer") ;
    searchFieldInput_= new UISelectBox("searchField", "", null ) ;
    termInput_ = new UIStringInput(TERM, "") ;
    add(termInput_ ) ;
    add(searchFieldInput_);
    addActionListener(AdvancedSearchActionListener.class, ADVANCED_SEARCH_ACTION) ;
    addActionListener(SearchActionListener.class, SEARCH_ACTION) ;
  }

  public String getSearchAction(){ return SEARCH_ACTION ; }
  public String getAdvancedSearchAction(){ return ADVANCED_SEARCH_ACTION ; }
  public boolean isRendered() { return true ; }

  public void setSearchOptions(List options) {
    searchOptions_ = options ;
    searchFieldInput_.setOptions(options) ;
  }

  static public class SearchActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UISearchBar uiForm =  (UISearchBar) event.getSource();
      String term  = uiForm.termInput_.getValue() ;
      //if(term == null || term.length() == 0) return ;
      if(term == null) return ;
      String select = uiForm.searchFieldInput_.getValue() ;
      List fields = new ArrayList() ;
      if("".equals(select)) {
        for(int i = 0; i < uiForm.searchOptions_.size(); i++) {
          SelectItem item = (SelectItem) uiForm.searchOptions_.get(i) ;
          if(item.value_.length() > 0) {
            fields.add(item.value_) ;
          }
        }
      } else {
        fields.add(select) ;
      }
      UISearcher uiSearcher = (UISearcher) uiForm.getParent() ;
      uiSearcher.quickSearch(term, fields) ;
    }
  }

  static public class AdvancedSearchActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UISearchBar uiSearch =  (UISearchBar) event.getSource();
      UISearcher uiSearcher = (UISearcher) uiSearch.getParent() ;
      uiSearcher.showAdvancedSearch() ;
    }
  }

  public String getTemplatePath() {  return template_ ; }
  public void   setTemplatePath(String s) { template_ =  s ; }
}