/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.portal.config.impl;

import java.util.List;

import org.exoplatform.container.configuration.ConfigurationManager;
import org.exoplatform.container.xml.InitParams;
import org.exoplatform.services.database.HibernateService;
import org.exoplatform.services.organization.User;
import org.exoplatform.services.organization.UserEventListener;
import org.hibernate.Session;
/**
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Wed, Feb 18, 2004 @ 21:33 
 */
public class PortalUserEventListenerImpl extends UserEventListener {
  private PortalConfigServiceImpl pservice_ ;
  private HibernateService hservice_ ;
  
  public PortalUserEventListenerImpl(PortalConfigServiceImpl pservice,
                                     ConfigurationManager cservice, 
                                     HibernateService hservice,
                                     InitParams params) throws Exception {
    pservice_ = pservice ;
    hservice_ = hservice ;    
  }
 
  public void preSave(User user, boolean isNew) throws Exception {    
  
  }

  public void preDelete(User user) throws Exception {
    Session session = hservice_.openSession() ;
    String owner = user.getUserName();
    List entries = 
      session.createQuery(PortalConfigServiceImpl.queryPageDataByOwner).setString(0, owner).list();
    for(int i=0; i<entries.size(); i++) 	{
      if( entries.get(i) != null) session.delete(entries.get(i));
    }
    Object obj = session.get(PortalConfigData.class, owner) ;
    if( obj != null) session.delete(obj);
    if( obj != null) session.delete(session.get(NodeNavigationData.class, owner)) ;
    session.flush() ;
    pservice_.onModifiedOwner(owner) ;
  } 
}
