package org.exoplatform.portal.faces.component;

import java.util.ArrayList;
import java.util.List;

import org.exoplatform.container.SessionContainer;
import org.exoplatform.container.client.http.HttpClientInfo;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.config.model.Node;
import org.exoplatform.portal.session.ExoPortal;
import org.exoplatform.portal.session.RequestInfo;
/**
 * @version $Revision: 1.11 $ $Date: 2004/09/27 18:26:58 $
 * @author Fahrid Djebbari
 */
public class UINavigation extends UIExoCommand {
  static String CHANGE_NODE_ACTION = "changeNode" ;
  static public Parameter CHANGE_NODE = new Parameter(ACTION, CHANGE_NODE_ACTION);
 
  protected Node rootNode_ ;
  private String preferedMimetype_ ;
  private String ownerURI_ ;
  
	public UINavigation() throws Exception {
		setId("UINavigation");
    HttpClientInfo info = (HttpClientInfo) SessionContainer.getInstance().getClientInfo() ;
    RequestInfo rinfo = (RequestInfo)SessionContainer.getComponent(RequestInfo.class);
    ownerURI_ = rinfo.getOwnerURI() ;
    preferedMimetype_ = info.getPreferredMimeType() ;
    addActionListener(ChangeNodeActionListener.class, CHANGE_NODE_ACTION) ;
	}
  
  public Node getRootNode() { 
    ExoPortal portal = (ExoPortal)SessionContainer.getComponent(ExoPortal.class) ;
    return  portal.getRootNode();  
  }
  
  public Node getSelectedNode()  { 
    ExoPortal portal = (ExoPortal)SessionContainer.getComponent(ExoPortal.class) ;
    return  portal.getSelectedNode() ; 
  }
  
  public List getSelectedPath()  { 
    ExoPortal portal = (ExoPortal)SessionContainer.getComponent(ExoPortal.class) ;
    Node node = portal.getSelectedNode() ;
    List list = new ArrayList() ;
    while (node != null) {
      list.add(node) ;
      node = node.getParent() ;
    }
    List nodes = new ArrayList() ;
    for(int i = list.size() - 1 ; i >= 0 ; i--) {
      nodes.add(list.get(i)) ;
    }
    return  nodes ; 
  }
  
  public String getPreferedMimeType() { return preferedMimetype_ ; }
  
  public String getOwnerURI()  { return ownerURI_ ;}
  
	static public class ChangeNodeActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
			String uri = event.getParameter("uri");
      ExoPortal portal = (ExoPortal)SessionContainer.getComponent(ExoPortal.class) ;
			Node node = portal.getRootNode().findNode(uri) ;
			portal.setSelectedPage(node) ;
		}
	}
}