/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.faces.listener.portal;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portal.PortalConstants;
import org.exoplatform.portal.config.PortalConfigService;
import org.exoplatform.portal.config.model.PortalConfig;
import org.exoplatform.portal.faces.component.PortalComponentCache;
import org.exoplatform.portal.faces.component.UIContainer;
import org.exoplatform.portal.faces.component.UIPortal;
import org.exoplatform.portal.faces.component.UIPortalComponent;
import org.exoplatform.portal.faces.component.UIPortalForm;
import org.exoplatform.portal.faces.component.UIPortlet;
import org.exoplatform.portal.faces.component.logic.PortalLocale;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 16, 2004
 * @version $Id: PortalActionListener.java,v 1.3 2004/09/27 20:44:59 tuan08 Exp $
 */
public class PortalActionListener extends ExoActionListener  {
  public void execute(ExoActionEvent event) throws Exception {
    UIPortal uiPortal = (UIPortal) event.getSource() ;
    String portalAction = event.getAction() ;
    if (PortalConstants.SAVE_PORTAL_ACTION.equals(portalAction)) {
      if(!uiPortal.isDirty()) return ;
      PortalConfigService service = 
        (PortalConfigService)PortalContainer.getInstance().
                             getComponentInstanceOfType(PortalConfigService.class) ;
      UIContainer uiLayout = (UIContainer) uiPortal.getChildren().get(0) ;
      uiLayout.buildTreeModel(null) ;
      PortalConfig componentModel = uiPortal.getPortalConfigModel() ;
      componentModel.setLayout(uiLayout.getContainerModel()) ;
      service.savePortalConfig(componentModel, UIExoCommand.getRemoteUser()) ;
      uiPortal.setComponentDirty(false) ;
      uiPortal.clearComponentModified() ;
    } else  if (PortalConstants.EDIT_PORTAL_ACTION.equals(portalAction)) {
      UIPortalForm uiPortalForm = 
        (UIPortalForm)PortalComponentCache.findPortalComponent(UIPortalForm.class) ;
      uiPortalForm.setUIPortal(uiPortal);
      uiPortal.setBodyComponent(uiPortalForm) ;
    } else  if(PortalConstants.DRAG_DROP_ACTION.equals(portalAction)) {
      UIContainer  uiContainer = (UIContainer) uiPortal.getChildren().get(0) ;
      String srcid = event.getParameter(PortalConstants.DRAG_SRC_PARAM) ;
      srcid =  srcid.substring(0, srcid.indexOf("-customizable-block")) ;
      UIPortalComponent uiSrc = 
        (UIPortalComponent)uiContainer.findComponentById(srcid) ;
      String targetid = event.getParameter(PortalConstants.DROP_TARGET_PARAM);
      UIPortalComponent uiTarget = null ;
      boolean targetIsInfoBar =  false ;
      if(targetid.endsWith("-customizable-block")) {
        targetid =  targetid.substring(0, targetid.indexOf("-customizable-block")) ;
      } else {
        targetid =  targetid.substring(0, targetid.indexOf("-info-bar")) ;
        targetIsInfoBar =  true ;
      }
      uiTarget = (UIPortalComponent)uiContainer.findComponentById(targetid) ;
      if(uiSrc == null ||  uiTarget == null) {
        Information iprovider = findInformationProvider(uiPortal) ;
        iprovider.addMessage(new ExoFacesMessage("#{UIPortal.msg.cannot-find-src-target}")) ;
        return ;
      }
      UIPortalComponent parent = (UIPortalComponent)uiSrc.getParent() ;
      parent.removeChild(uiSrc) ;
      UIContainer uiContainerTarget = null ;
      if(targetIsInfoBar || uiTarget instanceof UIPortlet) {
        Object obj = uiTarget.getParent()  ;
        if(obj instanceof UIContainer) {
          uiContainerTarget = (UIContainer) obj ;
          uiContainerTarget.insertChildBefore(uiSrc, uiTarget) ;
        } else {
          uiContainerTarget = (UIContainer) uiTarget ;
          uiContainerTarget.insertChildBefore(uiSrc, null) ;
        }
      } else {
        uiContainerTarget = (UIContainer)uiTarget  ;
        uiContainerTarget.insertChildBefore(uiSrc, null) ;
      }
    } else if(PortalConstants.CHANGE_LANGUAGE_ACTION.equals(portalAction)) {
      String localeName = event.getParameter(PortalConstants.LANGUAGE_PARAM) ;
      PortalLocale.changeLocale(uiPortal, localeName) ;
      PortalLocale.changeLocale(uiPortal.getCurrentUIPage()) ;
    }
  }
}