/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.servlet;

import java.io.IOException;
import java.io.InputStream;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.StringUtils;
import org.exoplatform.commons.utils.ExceptionUtil;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.RootContainer;
import org.exoplatform.services.download.DownloadResource;
import org.exoplatform.services.download.DownloadService;
/**
 * Created by The eXo Platform SARL        .
 * Sun, Dec 28, 2003 @ 14:57 
 * @author: Tuan Nguyen
 * @version: $Id: FileContentServlet.java,v 1.3 2004/06/23 03:19:01 tuan08 Exp $
 * @email: tuan08@yahoo.com
 */
public class DownloadServlet extends HttpServlet {
  private String portal_ ;
  
  public void init(ServletConfig config) throws ServletException {
    portal_ = config.getServletContext().getServletContextName() ;
  }
  
	public void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    response.setHeader("Cache-Control", "private max-age=600, s-maxage=120");
		try {      
      String resourceId = request.getParameter("resourceId") ;      
      PortalContainer pcontainer = getPortalContainer() ;
      PortalContainer.setInstance(pcontainer) ;
      DownloadService dservice = 
        (DownloadService) pcontainer.getComponentInstanceOfType(DownloadService.class) ;
      DownloadResource dresource = dservice.getDownloadResource(resourceId);
      String resourceName = dresource.getDownloadName() ;
      if( resourceName != null ){
        String fileName = StringUtils.deleteWhitespace(resourceName) ;        
        response.setHeader("Content-Disposition","attachment;filename="+fileName);
      }
      if(dresource != null)  {
        response.setContentType(dresource.getResourceMimeType()) ;
        InputStream is = dresource.getInputStream() ;
        byte[] buf = new byte[is.available()] ;
        is.read(buf) ;
        response.setContentType(dresource.getResourceMimeType()) ;          
        response.getOutputStream().write(buf) ;        
        is.close();
      } else {              
        response.setContentType("text/plain") ;                
        response.getWriter().write("NO DOWNDLOAD RESOURCE CONTENT  OR YOU DO NOT HAVE THE RIGHT TO ACCESS THE CONTENT") ;        
      }
      
		} catch (Exception ex) {
			ex.printStackTrace() ;	
			String s = ExceptionUtil.getStackTrace(ex, 20) ;
      response.getOutputStream().println(s) ;
		} finally {
			PortalContainer.setInstance(null) ;
		}
	}
  
  private  PortalContainer getPortalContainer() {
    PortalContainer pcontainer =  RootContainer.getInstance().getPortalContainer(portal_) ;
    return pcontainer ;
  }
}
