/***************************************************************************
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlet.commons;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import org.exoplatform.container.ExoContainer;
import org.exoplatform.container.ExoContainerContext;
import org.exoplatform.services.naming.InitialContextInitializer;

/**
 * Created by The eXo Platform SARL .
 * patch for Tomcat's InitialContext
 * in web.xml 
 * <listener>
 *   <listener-class>org.exoplatform.portlet.commons.InitialContextRecallListener</listener-class>
 * </listener>
 * @author Gennady Azarenkov
 * @version $Id: $
 */
public class InitialContextRecallListener implements
    ServletContextListener {

  /* (non-Javadoc)
   * @see javax.servlet.ServletContextListener#contextInitialized(javax.servlet.ServletContextEvent)
   */
  public void contextInitialized(ServletContextEvent event) {

    // Patch for tomcat InitialContext
    ExoContainer container = ExoContainerContext.getTopContainer();
    InitialContextInitializer ic = (InitialContextInitializer) container 
    .getComponentInstanceOfType(InitialContextInitializer.class);

    
    if (ic != null) {
      ic.recall();
    }
    
    // ////////////////////////////////

  }

  /* (non-Javadoc)
   * @see javax.servlet.ServletContextListener#contextDestroyed(javax.servlet.ServletContextEvent)
   */
  public void contextDestroyed(ServletContextEvent event) {
  }

}