/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.jmx.component.model;

import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import javax.management.MBeanServer;
import javax.management.ObjectName;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIMBeanServer.java,v 1.2 2004/08/01 04:18:27 tuan08 Exp $
 */
public class JMXServer  {
  private Map<String, MBeanCategory> categories_ =  new HashMap<String,MBeanCategory>() ;
	private MBeanServer mserver_ ;
  private boolean select_ ;
  private String id_ ;
  
  public JMXServer(MBeanServer server) {
    mserver_ = server ;
    Set names = mserver_.queryNames(null, null) ;
    Iterator i = names.iterator() ;
    while(i.hasNext()) {
    	ObjectName oname = (ObjectName)i.next()  ;
      String categoryName = getCategory(oname) ;
      MBeanCategory category = categories_.get(categoryName) ;
      if(category == null) {
        category = new MBeanCategory(categoryName) ;
        category.setSelect(false) ;
        categories_.put(categoryName, category) ;
      }
      category.addObjectName(oname) ;
    }
    id_ =  Integer.toString(hashCode()) ;
  }
  
  public String getId()  {  return id_ ; }
  
  public MBeanServer getMBeanServer() { return mserver_ ; }
  
  public Map getCategoriesMap() { return categories_ ; }
  
  public Collection getCategories() { return categories_.values() ; }
  
  public String getName() { return mserver_.getDefaultDomain() ; }
  
  public boolean isSelect() { return select_ ; }
  public void    setSelect(boolean b) { select_ = b ; }
  
  public MBeanCategory  getDefaultCategory() {
    Iterator i = categories_.values().iterator() ;
    if(i.hasNext())  return (MBeanCategory)i.next() ;
    return null ;
  }
  
  private String getCategory(ObjectName oname) {
    String name = oname.getCanonicalName() ;
    int idx = name.indexOf('=') ;
    name = name.substring(0, idx) ;
    return name ;
  }
  
  public MBeanDescription getMBeanDescription(String id) {
    for(MBeanCategory category : categories_.values()) {
      MBeanDescription  md = category.findMBeanDescription(id);
      if(md != null)  return md ;
    }
    return null ;
  }
}