/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.rss.component;

import javax.faces.context.FacesContext;
import javax.portlet.PortletPreferences;
import javax.portlet.PortletRequest;

import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.validator.EmptyFieldValidator;
import org.exoplatform.portlet.faces.component.UIPreferencesForm.UpdatePreferencesListener;

/**
 * Created by The eXo Platform SARL
 * Author : Thang Nguyen
 *          nqthang.net@gmail.com
 * Jun 23, 2006
 */
public class UIRssPreferencesForm extends UISimpleForm{
  private static String DESCRIPTION="description", URL_SOURCE = "url",CHANNEL = "channel", ITEM_TO_SHOW="item-to-show" ;
  public UIRssPreferencesForm() {
    super("UIRssPreferencesForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer") ;
    FacesContext context = FacesContext.getCurrentInstance();
    PortletRequest request = (PortletRequest) context.getExternalContext().getRequest();
    PortletPreferences  prefs = request.getPreferences();
    add(new UIStringInput(DESCRIPTION,  prefs.getValue(DESCRIPTION,"")).addValidator(EmptyFieldValidator.class)) ;
    add(new UIStringInput(URL_SOURCE,  prefs.getValue(URL_SOURCE,"")).addValidator(EmptyFieldValidator.class)) ;
    add(new UIStringInput(CHANNEL,  prefs.getValue(CHANNEL,"")).addValidator(EmptyFieldValidator.class)) ;
    add(new UIStringInput(ITEM_TO_SHOW,  prefs.getValue(ITEM_TO_SHOW,"")).addValidator(EmptyFieldValidator.class)) ;
    addActionListener(UpdatePreferencesListener.class, SAVE_ACTION);
  }

}
