package javax.portlet;

import java.util.*;

public class ValidatorException extends PortletException {

  private transient ArrayList failedKeyVector;

  private ValidatorException() {
    failedKeyVector = new ArrayList();
  }

  public ValidatorException(String text, Collection failedKeys) {
    super(text);
    failedKeyVector = new ArrayList();
    if (failedKeys != null) {
      failedKeyVector.addAll(failedKeys);
    }
  }

  public ValidatorException(String text, Throwable cause, Collection failedKeys) {
    super(text, cause);
    failedKeyVector = new ArrayList();
    if (failedKeys != null) {
      failedKeyVector.addAll(failedKeys);
    }
  }

  public ValidatorException(Throwable cause, Collection failedKeys) {
    super(cause);
    failedKeyVector = new ArrayList();
    if (failedKeys != null) {
      failedKeyVector.addAll(failedKeys);
    }
  }

  public Enumeration getFailedKeys() {
    return Collections.enumeration(failedKeyVector);
  }
}
