/***************************************************************************
 * Copyright 2001-2007 The eXo Platform SAS          All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package javax.portlet.filter;

import java.util.Enumeration;
import java.util.Map;

import javax.portlet.EventRequest;
import javax.portlet.EventResponse;
import javax.portlet.FragmentURL;
import javax.portlet.PortletMode;
import javax.portlet.PortletModeException;
import javax.portlet.PortletURL;
import javax.portlet.ResourceURL;
import javax.portlet.WindowState;
import javax.portlet.WindowStateException;
import javax.xml.namespace.QName;

public class EventResponseWrapper implements EventResponse {

  EventResponse response;
  
  private EventResponseWrapper() {
  }
  
  public EventResponseWrapper(EventResponse response) {
    this.response = response;
  }

  public void setEvent(QName name, Object value) {
    response.setEvent(name, value);
  }

  public void setEvents(Map events) {
    response.setEvents(events);
  }

  public void setPortletMode(PortletMode portletMode) throws PortletModeException {
    response.setPortletMode(portletMode);
  }

  public void setRenderParameter(String key, String value) {
    response.setRenderParameter(key, value);
  }

  public void setRenderParameter(String key, String[] values) {
    response.setRenderParameter(key, values);
  }

  public void setRenderParameters(Map parameters) {
    response.setRenderParameters(parameters);
  }

  public void setWindowState(WindowState windowState) throws WindowStateException {
    response.setWindowState(windowState);
  }

  public void addProperty(String key, String value) {
    response.addProperty(key, value);
  }

  public void addProperty(String key, String value, int scope) {
    response.addProperty(key, value, scope);
  }

  public PortletURL createActionURL() {
    return response.createActionURL();
  }

  public PortletURL createRenderURL() {
    return response.createRenderURL();
  }

  public ResourceURL createResourceURL() {
    return response.createResourceURL();
  }
  
  public ResourceURL createResourceURL(boolean markupContainsPortletURLs) {
    return response.createResourceURL(markupContainsPortletURLs);
  }

  public String encodeURL(String path) {
    return response.encodeURL(path);
  }

  public String getNamespace() {
    return response.getNamespace();
  }

  public void setProperty(String key, String value) {
    response.setProperty(key, value);
  }

  public void setProperty(String key, String value, int scope) {
    response.setProperty(key, value, scope);
  }

  public EventResponse getResponse() {
    return response;
  }

  public void setResponse(EventResponse response) {
    this.response = response;
  }

  public PortletMode getPortletMode() {
    return response.getPortletMode();
  }

  public Map getRenderParameterMap() {
    return response.getRenderParameterMap();
  }

  public WindowState getWindowState() {
    return response.getWindowState();
  }

  public FragmentURL createFragmentURL() {
    return response.createFragmentURL();
  }

  public void setNextPossiblePortletModes(Enumeration portletModes) {
    response.setNextPossiblePortletModes(portletModes);
  }
  
  public void setRenderParameters(EventRequest request) {
    response.setRenderParameters(request);         
  }
  
}
