/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portletcontainer.pci.model;

import java.util.ArrayList;
import java.util.List;

import org.exoplatform.Constants;

/**
 * Jul 11, 2004 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: PortletApp.java,v 1.1 2004/07/13 02:31:13 tuan08 Exp $
 */
public class PortletApp {
	private List portlet;
  private String version;
  private List customWindowState;
  private List customPortletMode;
  private List securityConstraint;
  private List userAttribute;
  private List eventDefinition;
  private List sharedSessionAttribute;
  private List sharedRenderParameter;
	private List filter;
	private List filterMapping;
  private String id;
  //Portlet spec 2 add:
  private String resourceBundle;  
  
  public PortletApp() {
  	portlet = new ArrayList();
    customWindowState = new ArrayList();
    customPortletMode = new ArrayList();
    securityConstraint = new ArrayList();
    userAttribute = new ArrayList();
    eventDefinition = new ArrayList();
    sharedSessionAttribute = new ArrayList();
    sharedRenderParameter = new ArrayList();
  }
  
  public List getPortlet() { return this.portlet; }
  public void addPortlet(Portlet p) { this.portlet.add(p); }
  
  public String getVersion() { return this.version; }
  public void setVersion(String value) { this.version = value; }

	public List getFilter() {
    if(filter == null) return Constants.EMPTY_LIST ;  
		return filter;
	}

	public void setFilter(List filter) {
		this.filter = filter;
	}

  public void addFilter(Filter f) {
   if(filter == null) filter = new ArrayList();  
   this.filter.add(f) ; 
  }
  
	public List getFilterMapping() {
    if(filterMapping == null) return Constants.EMPTY_LIST ;  
		return filterMapping;
	}

	public void setFilterMapping(List filter) {
		this.filterMapping = filterMapping;
	}

  public void addFilterMapping(FilterMapping f) {
   if(filterMapping == null) filterMapping = new ArrayList();  
   this.filterMapping.add(f) ; 
  }
  
  public List getCustomWindowState() { return this.customWindowState; }
  public void addCustomWindowState(CustomWindowState value) { 
    this.customWindowState.add(value); 
  }

  public List getCustomPortletMode() { return this.customPortletMode;}
  public void addCustomPortletMode(CustomPortletMode mode) {
    this.customPortletMode.add(mode);
  }

  public List getSecurityConstraint() { return this.securityConstraint; }
  public void addSecurityConstraint(SecurityConstraint sc) {
  	this.securityConstraint.add(sc);
  }
  
  public List getUserAttribute() { return userAttribute; }
  public void addUserAttribute(UserAttribute att) {
  	this.userAttribute.add(att);
  }

  public List getEventDefinition() { return eventDefinition; }
  public void addEventDefinition(EventDefinition edef) {
  	this.eventDefinition.add(edef);
  }

  public List getSharedSessionAttribute() { return sharedSessionAttribute; }
  public void addSharedSessionAttribute(SharedSessionAttribute ssa) {
  	this.sharedSessionAttribute.add(ssa);
  }

  public List getSharedRenderParameter() { return sharedRenderParameter; }
  public void addSharedRenderParameter(SharedRenderParameter srp) {
  	this.sharedRenderParameter.add(srp);
  }

  public String getId() { return this.id; }

  public void setId(String value) { this.id = value; }
  
  //Portlet spec 2 add:
  public String getResourceBundle() {
    return resourceBundle;
  }

  public void setResourceBundle(String resourceBundle) {
    this.resourceBundle = resourceBundle;
  }
}