package org.esupportail.cas.server.handlers.database;

import org.dom4j.Element;

/**
 * This class implements a bind database handler class. It is used by
 * GenericHandler.
 *
 * This class is not really needed today because inherinting from
 * DatabaseHandler but has been kept for the homogeneity of the sources.
 *
 * @author Pascal Aubry <pascal.aubry at univ-rennes1.fr>
 */
public final class BindDatabaseHandler extends DatabaseHandler {
	
	/**
	 * Constructor.
	 *
	 * @param handlerElement the XML element that declares the handler 
	 * in the configuration file
	 * @param configDebug debugging mode of the global configuration
	 * @throws Exception Exception
	 */
	public BindDatabaseHandler(
			final Element handlerElement, 
			final Boolean configDebug) throws Exception {
		super(handlerElement, configDebug);
		traceBegin();

		// add the database servers
		addServers(true/*serverElementNeeded*/, getClass().getPackage().getName() + ".BindDatabaseServer");

		traceEnd();
	}

}

