/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.admin;


import condition.* ;
import suites.share.*;
import suites.share.NewAccountSuite ;
import suites.share.CommonUnit ;
import suites.share.UserLoginSuite;
import suites.share.UserLogoutSuite;

import org.exoplatform.test.*;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.* ;

public class PortletRegistryPortalSuite extends WebUnitSuite {     
    static String DESC = "Go to PortletRegistry page and test all the basic actions at the group tab" ;
    static String NAME = "PortletRegistrySuite" ;
    String COMMENT = "When you running portal and you want to registry portlet, you use this suite." +
        "it set field portlet_2 at line 76, it is difference with PortletRegistrySuite ( use when you " +
        "want to registry portlet in ECM )" ;
    
    public PortletRegistryPortalSuite() {    
      super(NAME, DESC) ;
      init("/Home/Portlet Registry") ;
    }  
    public PortletRegistryPortalSuite(String path) {
      super(NAME, DESC) ;
      init(path) ;
    }  
    public void  init(path) {      
    goToPage(path) ;    
    addWebUnit(
      new ClickLink("EmtyDatabase", "Remove all the categories").
      setTextLink("Remove All").setBlockId("page")
    ) ;
       
    //Add a new category------
    addWebUnit(
      new ClickLinkWithText("CreateNewCategory", "Create a new portlet category").
      setTextLink("Add Category").
		  addValidator(new ExpectFormIdValidator("portletCategoryForm"))
		) ; 
    addWebUnit(
      new SubmitFormUnit("SubmitCategroryForm", "Fill the portlet category and submit").
      setFormId("portletCategoryForm").
      setField(name:"NewCategory", description:"For any users",op:"save").
      addValidator(new ExpectLinkWithTextValidator("NewCategory"))
    ) ;
    //Edit created category----------
    addWebUnit(
      new ClickURLLinkUnit("EditCreatedCategory", "Edit the created category if present").
      setURL("&uicomponent=UIPortletCategories&op=editCategory&objectId=NewCategory").
      addValidator(new ExpectFormIdValidator("portletCategoryForm"))
    ) ;    
    addWebUnit(
      new SubmitFormUnit("SubmitCategoryForm", "Edit the portlet category and submit").
      setFormId("portletCategoryForm").
      setField(name:"Category.u", description:"Update New Category",op:"save").
      addValidator(new ExpectLinkWithTextValidator("Category.u"))
    ) ;    
    //On category
    //-----Add a portlet----
    addWebUnit(
      new ClickURLLinkUnit("ClickAddPortlet", "add portlet for the new created category").
      setURL("&uicomponent=UIPortletCategories&op=addPortlet&objectId=NewCategory").
	    addValidator(new ExpectFormIdValidator("portletForm"))
	  ) ;      
    addWebUnit(
      new SubmitFormUnit("SubmitPortletForm", "Submit the add portlet form").
      setFormId("portletForm").
      setField(portlet_2:"content/DisplayStaticContent", op:"save").
      addValidator(new ExpectTextValidator("Category.u"))  
    ) ;
    //-----On portlet
    //----------Edit portlet role----    
    addWebUnit(
      new ClickURLLinkUnit("EditPortletRole", "Click on the edit role link of the first portlet").
      setURL("uicomponent=UIPortletCategories&op=editRole").              
      setBlockId("page").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIPortletPermission&op=addPermission"))
    ) ;
    //---------------Add permision--------
    addWebUnit(
      new ClickURLLinkUnit("AddPermission", "add a permission to the  portlet").
      setURL("uicomponent=UIPortletPermission&op=addPermission").
      setBlockId("page").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIExoPermissionBrowser&op=selectGroup&objectId=/admin"))      
    ) ; 
    //--------------------Select permision--------   
    addWebUnit(
      new ClickURLLinkUnit("SelectPermision", "Select a Permision to the portlet").
      setURL("&uicomponent=UIExoPermissionBrowser&op=selectPermission&objectId=*:/user").      
      setBlockId("page").
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPortletPermission&op=addPermission"))      
    ) ;    
    //---------------Back to the list category
    addWebUnit(
      new ClickURLLinkUnit("GoBackToCategoryList", "Click cancel to go back to the list category view").
      setURL("uicomponent=UIPortletPermission&op=PhaseId[1].cancel").
      setBlockId("page")
    ) ;    
    //----------Edit portlet properties---
    addWebUnit(
      new ClickURLLinkUnit("EditCreatedPortlet", "Click on edit portlet").
      setURL("uicomponent=UIPortletCategories&op=editPortlet").
		  addValidator(new ExpectFormIdValidator("portletForm"))
		) ;
    addWebUnit(
   	  new SubmitFormUnit("SubmitPortletForm", "Fill the portlet form  and submit").
      setFormId("portletForm").
      setField(name:"DisplatContentPortlet(updated)", description:"description (updated)").
      setField("op","save").
      addValidator(new ExpectTextValidator("DisplatContentPortlet(updated)"))
    ) ;        
    //**Save admin context
    addWebUnit(
      new ContextManagementUnit(ContextManagementUnit.SAVE, "Save Context")
    );    
    //**Create, login, add a portlet with a new account    
    addWebSuite(new NewAccountSuite()) ;
    String[] roles=["user"];
    addWebSuite(new UserLoginSuite("#{client.name}", "#{client.name}", roles)) ;   
    addWebUnit(CommonUnit.createClickEditPageMode()) ;    
    //**-----Add a new portlet
    addWebUnit(
        new ClickURLLinkUnit("AddPortlet", "tell web client click addPortlet").
        setURL("componentId=page&portal:action=addPortlet").
        addValidator(new ExpectTextValidator("Category.u")).
        addValidator(new ExpectTextValidator("DisplatContentPortlet(updated)"))        
    ) ;
    //**Restore admin context 
    addWebUnit(
      new ContextManagementUnit(ContextManagementUnit.RESTORE, "Restore Context")
    );
    //**Go to Portlet Registry
    goToPage(path) ;        
    //Delete created portlet----
    addWebUnit(
      new ClickURLLinkUnit("DeleteCreatedPortlet", "Remove the created portlet if present").
      setURL("&uicomponent=UIPortletCategories&op=deletePortlet&objectId=NewCategory/DisplayStaticContent")
    ) ;    
    //Delete created category--------
    addWebUnit(
      new ClickURLLinkUnit("DeleteCreatedCategories", "Delete the created category if present").
      setURL("uicomponent=UIPortletCategories&op=deleteCategory&objectId=NewCategory")
    ) ;    
    
    addWebUnit(
      new ClickLink("ImportCatgories", "Import the available portlets from the portlet container").
      setTextLink("Import Portlets")
    ) ;        
  }
  public java.util.List getRequiredSuites() { 
  	String[] roles = ["user", "admin"] ;
   	return [new UserLoginSuite(CommonUnit.NAME_EXO_ADMIN, "exo", roles)] ;
  } 
}
