/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.admin;

import condition.* ;
import suites.share.CommonUnit ;
import suites.share.UserLoginSuite;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import suites.share.UserLogoutSuite;

/**
 * this suite does: 
 *  1)Go to Manage Metadata on Admin the ECM tab 
 *  2)View some properties of dc:elementSet
 *  3)Apply some metadata
 *  4)Go to select workspace
 * Created by The eXo Platform SARL
 * Author : Hoa Nguyen Thi
 *          hoa2501@yahoo.com
 * Apr 5, 2005
 */
public class AdminManageMetadataSuite extends WebUnitSuite {
  static String DESC = "Go to Manage Metadata and test all basic actions" ;
  static String NAME = "AdminManageMetadataSuite" ;
  String COMMENT = null;   
  public AdminManageMetadataSuite() {    
    super(NAME, DESC) ;     
    goToPage("/Home/ecm") ;
    //Click Admin The ECM
    addWebUnit(
      new ClickURLLinkUnit("SelectAdminTheECM", "Select Admin The ECM tab").
      setURL("componentId=ECMPage&portal:action=changeTab&objectId=ecm").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIECMAdminSummary&op=addEditView"))      
    ) ;      
    addWebUnit(
      new ClickURLLinkUnit("ClickManageMetadata", "Click on Manage Metadata icon").
      setURL("uicomponent=UIECMAdminSummary&op=manageMetadata").          
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIMetadataManager&op=view&objectId=dc:elementSet"))      
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickViewMetadata", "Click on view icon at row of dc:elementSet").
        setURL("uicomponent=UIMetadataManager&op=view&objectId=dc:elementSet").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIMetadataView&op=back"))        
    ) ;  
    addWebUnit(
        new ClickURLLinkUnit("GoToListMetadata", "Click on back icon to comeback list metadata").
        setURL("uicomponent=UIMetadataView&op=back").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIMetadataManager&op=back"))
    ) ;      
    addWebUnit(
        new ClickURLLinkUnit("GoBackWorkspace", "Click on back icon to go to workspace").
        setURL("uicomponent=UIMetadataManager&op=back").                  
        addValidator(new ExpectLinkWithURLValidator("portal:componentId=ECMPage&portal:action=changeTab&objectId=jcr"))
    ) ;
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user", "admin"] ;
    return [new UserLoginSuite(CommonUnit.NAME_EXO_ADMIN, "exo", roles)] ;
  }  
}