/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.admin;

import condition.* ;
import suites.share.CommonUnit ;
import suites.share.UserLoginSuite;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import suites.share.UserLogoutSuite;

/** 
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Aug 03, 2006
 */
public class AdminTaxonomyDriveSuite extends WebUnitSuite {
  static String DESC = "Go to ECM File Explorer page, select Taxonomy drive and test all the basic actions" ;
  static String NAME = "AdminTaxonomyDriveSuite" ;
    
  public AdminTaxonomyDriveSuite() {    
    super(NAME, DESC) ;   
    goToPage("/Home/ecm") ;
    //Select Admin on production 
    addWebUnit(
      new ClickURLLinkUnit("SelectECMFileExplorer", "Select ECM File Explorer tab").
      setURL("componentId=ECMPage&portal:action=changeTab&objectId=jcr")            
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("SelectDrive", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectDrive").
      addCondition(new HaveLinkWithURLCondition("&uicomponent=MainToolbar&op=selectDrive")).
      addValidator(new ExpectTextValidator("Admin on production"))        
    ) ;      
    addWebUnit(
      new ClickLinkWithText("ClickOnAdminOnProduction", "click on Admin on production link").
      setTextLink("Admin on production").               
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=selectDrive"))      
    ) ;     
    addWebUnit(
      new SubmitFormUnit("SelectAdminView", "click on save button").
      setFormId("UISelectViewForm").   
      setField("views","admin-view").            
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIViewController&op=selectNode&objectId=Admin"))                                                   
    ) ;   
    //-----Select Actions tab
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").               
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addFolder"))      
    ) ; 
    //-----Goto /home/users/exoadmin
   addWebUnit(
      new ClickURLLinkUnit("ClickOnHome", "click on home link").
      setURL("&uicomponent=UIContentManager&op=changeNode&objectId=/home").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIContentManager&op=changeNode&objectId=/home/users"))     
    ) ; 
    addWebUnit(
      new ClickURLLinkUnit("ClickOnUsers", "click on users link").
      setURL("&uicomponent=UIContentManager&op=changeNode&objectId=/home/users").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIContentManager&op=changeNode&objectId=/home/users/exoadmin"))      
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("ClickOnCurrentUser", "click on current user link").
      setURL("&uicomponent=UIContentManager&op=changeNode&objectId=/home/users/exoadmin")
    ) ;
    
    //-----Delete test-folder if does exist    
    addWebUnit(
      new ClickURLLinkUnit("DeleteExistedFolder", "Delete if test-folder is existed").
      setURL("&uicomponent=UIContentManager&op=removeNode&objectId=/home/users/exoadmin/test-folder").
      addCondition(new HaveLinkWithTextCondition("test-folder")).
      addValidator(new ExpectTextValidator("The node /home/users/exoadmin/test-folder has been removed."))
    ) ;            
    //-----Add folder directory
    addWebUnit(
      new ClickURLLinkUnit("ClickOnAddFolder", "click on Add Folder button").
      setURL("&uicomponent=UIToolbar&op=addFolder").                  
      addValidator(new ExpectFormIdValidator("folderForm"))      
    ) ;        
    //----------Add nt:unstructured folder
    addWebUnit(
      new SubmitFormUnit("Add Unstructured Folder", "Select type is nt:unstructured and click on Save button").
      setFormId("folderForm").   
      setField("folderType","nt:unstructured").
      setField("name","test-folder").
      setField("op","save").
      addValidator(new ExpectTextValidator("test-folder"))      
    ) ;             
    //-----Go to test-folder
    addWebUnit(
      new ClickURLLinkUnit("GotoTest-folder", "click on test-folder").
      setURL("&uicomponent=UIContentManager&op=changeNode&objectId=/home/users/exoadmin/test-folder")      
    ) ;          
    //Click on Add document
    addWebUnit(
      new ClickURLLinkUnit("AddDocument", "click on Add Document button").
      setURL("uicomponent=UIToolbar&op=addDocument").    
      addValidator(new ExpectFormIdValidator("selectContentTypeForm")).
      addValidator(new ExpectFormIdValidator("contentForm"))
    ) ;   
    //-----Add new Nt:file document
    addWebUnit(
      new SubmitFormUnit("SelectNt:fileType", "select document type is nt:file").
      setFormId("selectContentTypeForm").   
      setField("contentType","nt:file").
      setField("op","changeType").
      addValidator(new ExpectFormIdValidator("contentForm"))      
    ) ;    
    //----------Save New Document
    addWebUnit(
      new SubmitFormUnit("SaveNewDocument", "click on save button").
      setFormId("contentForm").   
      setField("contentName","test-doc").
      //setField("summary","content").      
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentManager&op=editDocument&objectId=/home/users/exoadmin/test-folder/test-doc"))                                                   
    ) ;              
    //----------Select test-doc
    addWebUnit(
      new ClickURLLinkUnit("SelectTest-doc", "Click on test-doc link").
      setURL("&uicomponent=UIContentManager&op=changeNode&objectId=/home/users/exoadmin/test-folder/test-doc")      
    ) ;    
    //-----Manage Category
    addWebUnit(
      new ClickURLLinkUnit("SelectAdmintab", "Select Admin tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Admin").          
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIToolbar&op=manageCategories"))      
    ) ; 
    addWebUnit(
        new ClickURLLinkUnit("ClickOnManageCategory", "Click on Manage Category icon").
        setURL("uicomponent=UIToolbar&op=manageCategories").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UICategoriesList&op=add"))
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickAddCategory", "Click on Add Category icon").
        setURL("&uicomponent=UICategoriesList&op=add").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=JcrCategoryBrowser&op=selectNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/cms"))
    ) ;   
    addWebUnit(
        new ClickURLLinkUnit("Select cms", "Select cms").
        setURL("uicomponent=JcrCategoryBrowser&op=selectNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/cms").         
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UICategoriesList&op=delete&objectId=/jcr:system/exo:ecm/exo:taxonomies/cms"))
    ) ;       
    //Select Taxonomy drive
    addWebUnit(
      new ClickURLLinkUnit("SelectDrive", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectDrive").
      addCondition(new HaveLinkWithURLCondition("&uicomponent=MainToolbar&op=selectDrive")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDriveBrowser&op=selectWorkspace&objectId=Taxonomy"))        
    ) ;  
    addWebUnit(
      new ClickURLLinkUnit("SelectTaxonomyDrive", "Click on Taxonomy link").
      setURL("&uicomponent=UIDriveBrowser&op=selectWorkspace&objectId=Taxonomy").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIContentManager&op=changeNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/cms")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=editDocument")).
      addValidator(new ExpectTextValidator("taxonomy-list")).
      addValidator(new ExpectTextValidator("taxonomy-mac")).
      addValidator(new ExpectTextValidator("taxonomy-thumbnails"))
    ) ;        
    addWebUnit(
      new ClickURLLinkUnit("SelectCMS", "Click on cms link").
      setURL("&uicomponent=UIContentManager&op=changeNode&objectId=/jcr:system/exo:ecm/exo:taxonomies/cms").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIContentManager&op=viewNode&objectId=production:/home/users/exoadmin/test-folder/test-doc"))      
    ) ;  
    addWebUnit(
      new ClickURLLinkUnit("SelectTest-doc", "select test-doc").
      setURL("&uicomponent=UIContentManager&op=viewNode&objectId=production:/home/users/exoadmin/test-folder/test-doc").                           
      addValidator(new ExpectTextValidator("File Content"))
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("EditTest-doc", "click on edit icon").
      setURL("&uicomponent=UIToolbar&op=editDocument").      
      addValidator(new ExpectFormIdValidator("contentForm"))        
    ) ;
    addWebUnit(
      new SubmitFormUnit("Back", "click on cancel link").
      setFormId("contentForm").         
      setField("op","PhaseId[1].cancel").
      addValidator(new ExpectTextValidator("File Content"))      
    ) ; 
    addWebUnit(
      new ClickURLLinkUnit("SelectDrive", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectDrive").
      addCondition(new HaveLinkWithURLCondition("&uicomponent=MainToolbar&op=selectDrive")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDriveBrowser&op=selectWorkspace&objectId=Taxonomy"))      
    ) ;     
  }     
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user", "admin"] ;
    return [new UserLoginSuite(CommonUnit.NAME_EXO_ADMIN, "exo", roles)] ;
  }  
}