/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.temp;

import condition.* ;
import suites.share.* ;
import suites.share.CommonUnit ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;


/**
 * This suite depends on the AddFolderSuite one as the document is added in /test-folder
 *     1) Go to the exoadmin folder
 *     2) Add a 30 nt:file nodes
 *     3) Save session
 *     4) Return to workspace selection
 *
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * July 13, 2006
 */
public class AddMultiNodeSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page and add multi nodes to test-folder" ;
  static String NAME = "AddMultiNodeSuite" ;
    
  public AddMultiNodeSuite() {    
    super(NAME, DESC) ;
    goToPage("/Home/ecm") ;
    addWebUnit(
      new ClickURLLinkUnit("SelectDrive", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectDrive").
      addCondition(new HaveLinkWithURLCondition("&uicomponent=MainToolbar&op=selectDrive")).
      addValidator(new ExpectTextValidator("Admin on production"))        
    ) ;      
    addWebUnit(
      new ClickLinkWithText("ClickOnAdminOnProduction", "click on Admin on production link").
      setTextLink("Admin on production").               
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=selectDrive"))      
    ) ;              
    addWebUnit(
      new ClickURLLinkUnit("ClickOnHome", "click on home link").
      setURL("&uicomponent=UIContentManager&op=changeNode&objectId=/home").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIContentManager&op=changeNode&objectId=/home/users"))     
    ) ; 
    addWebUnit(
      new ClickURLLinkUnit("ClickOnUsers", "click on users link").
      setURL("&uicomponent=UIContentManager&op=changeNode&objectId=/home/users").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIContentManager&op=changeNode&objectId=/home/users/exoadmin"))      
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("ClickOnExoadmin", "click on current user link").
      setURL("&uicomponent=UIContentManager&op=changeNode&objectId=/home/users/exoadmin")
    ) ;     
    //Select Actions tab
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addDocument"))      
    ) ;
    for ( i in 1..30){ 
	    //Click on Add document
	    addWebUnit(
	      new ClickURLLinkUnit("AddDocument", "click on Add Document button").
	      setURL("uicomponent=UIToolbar&op=addDocument").    
	      addValidator(new ExpectFormIdValidator("selectContentTypeForm")).
	      addValidator(new ExpectFormIdValidator("contentForm"))
	    ) ;
	    //----------Save New Document
	    addWebUnit(
	      new SubmitFormUnit("SaveNewDocument", "click on save button").
	      setFormId("contentForm").   
	      setField("contentName","test-doc"+i).
	      setField("title","title"+i).      
	      setField("op","save").
	      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentManager&op=editDocument&objectId=/home/users/exoadmin/test-doc"))                                                   
	    ) ;                
	    	   
    }	    
   
    //Return to workspace selection
    addWebUnit(
      new ClickURLLinkUnit("SelectDrive", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectDrive").                  
      addValidator(new ExpectTextValidator("Drives"))      
    ) ;     
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user", "admin"] ;
    return [new UserLoginSuite(CommonUnit.NAME_EXO_ADMIN, "exo", roles)] ;
  }  
}