/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dung.hoang@exoplatform.com, jobdung@yahoo.com
 * Sep 28, 2006
 */
public class UserEnableJCRSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page, use Preference and test Enanble JCR like Structure action" ;
  static String NAME = "UserEnableJCRSuite" ;
  String COMMENT  = "You must run AdminViewSuite and AdminDriveSuite before run this suite";
  
  public UserEnableJCRSuite() {    
    super(NAME, DESC) ;  
    goToPage("/Home/ecm") ;
    addWebUnit(
      new ClickURLLinkUnit("ClickOnDrive-test", "click on drive-test button").
      setURL("&uicomponent=UIDriveBrowser&op=selectWorkspace&objectId=drive-test").               
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=selectDrive"))      
    ) ;      
    //Click on preferences icon
    addWebUnit(
      new ClickURLLinkUnit("ClickOnPreferences", "click on preferences icon").
      setURL("uicomponent=MainToolbar&op=preferences").                  
      addValidator(new ExpectFormIdValidator("preferencesForm"))      
    ) ; 
    addWebUnit(
      new SubmitFormUnit("SelectEnableJCRLikeStructure", "Select Enable JCR like structure and save").
      setFormId("preferencesForm").
      setCheckBox("checkbox",true).
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=saveSession"))
    ) ;    
    addWebUnit(
      new ClickURLLinkUnit("GoToWorkSpace", "Go to workspace").
      setURL("uicomponent=MainToolbar&op=selectDrive").                  
      addValidator(new ExpectTextValidator("workspace"))      
    ) ; 
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}