/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import suites.runner.ECMUserSuites;

/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserUploadSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page, click on upload and to do somethings" ;
  static String NAME = "UserUploadSuite" ;
  String COMMENT  = "You must run AdminViewSuite and AdminDriveSuite before run this suite";
  
  public UserUploadSuite() {    
    super(NAME, DESC) ;
    addWebSuite(new UserAddFolderSuite());   
    //Select Actions tab
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addFolder"))      
    ) ;
    //Upload a file to created Folder
    addWebUnit(
      new ClickURLLinkUnit("UploadFileToFolder", "click on Upload button").
      setURL("&uicomponent=UIToolbar&op=upload").                  
      addValidator(new ExpectFormIdValidator("uploadForm"))      
    ) ;
    //-----Save File
    def is;
    is= Thread.currentThread().
        getContextClassLoader().
        getResourceAsStream("META-INF/maven/exo-test/exo-test.webunit-framework/pom.xml") ;    
    
    addWebUnit(
      new SubmitFormUnit("UploadFile", "click on upload button").
      setFormId("uploadForm").   
      setFileField("upload","pom.xml", is).
      setField("op","uploadAction").      
      addValidator(new ExpectTextValidator("File:upload is uploaded successfully"))
    ) ;
    
    addWebUnit(
        new SubmitFormUnit("Save Uploaded File", "click on save button").
        setFormId("uploadForm").           
        setField("op","save").      
        addValidator(new ExpectTextValidator("File:upload is save successfully as nt:file node with name:upload"))
      ) ;
    
    addWebUnit(
        new ClickURLLinkUnit("Click Cancel Action", "click on cancel action").
        setURL("&uicomponent=UIContentUploader&op=PhaseId[1].cancel").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIContentManager&op=changeNode&objectId=/home/users/#{client.name}/test-folder/upload"))      
      ) ;
    
    if (UserECMFileExplorerSuite.isEnableJCR) {
      //Click on preferences icon
      addWebUnit(
        new ClickURLLinkUnit("ClickOnPreferences", "click on preferences icon").
        setURL("uicomponent=MainToolbar&op=preferences").                  
        addValidator(new ExpectFormIdValidator("preferencesForm"))      
      ) ; 
      addWebUnit(
        new SubmitFormUnit("SelectEnableJCRLikeStructure", "Select Enable JCR like structure and save").
        setFormId("preferencesForm").
        setCheckBox("checkbox",true).
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=saveSession"))
      ) ;
      //Save session
      addWebUnit(
        new ClickURLLinkUnit("SavedSession", "click on save Session button").
        setURL("&uicomponent=MainToolbar&op=saveSession").        
        addValidator(new ExpectTextValidator("All the changes have been saved"))      
      ) ;
    }     
    //Reupload the same file and check version
    addWebUnit(
      new ClickURLLinkUnit("ReuploadFileToFolder", "click on Upload button").
      setURL("&uicomponent=UIToolbar&op=upload").                  
      addValidator(new ExpectFormIdValidator("uploadForm"))      
    ) ;
    
    //-----Save File
    is = Thread.currentThread().
        getContextClassLoader().
        getResourceAsStream("META-INF/maven/exo-test/exo-test.webunit-framework/pom.xml") ;    
    
    addWebUnit(
        new SubmitFormUnit("UploadFile", "click on upload button").
        setFormId("uploadForm").   
        setFileField("upload","pom.xml", is).
        setField("op","uploadAction").      
        addValidator(new ExpectTextValidator("File:upload is uploaded successfully"))
      ) ;
      
      addWebUnit(
          new SubmitFormUnit("Save Uploaded File", "click on save button").
          setFormId("uploadForm").           
          setField("op","save").      
          addValidator(new ExpectTextValidator("File:upload is save successfully as nt:file node with name:upload"))
        ) ;
      
      addWebUnit(
          new ClickURLLinkUnit("Click Cancel Action", "click on cancel action").
          setURL("&uicomponent=UIContentUploader&op=PhaseId[1].cancel").                  
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIContentManager&op=changeNode&objectId=/home/users/#{client.name}/test-folder/upload"))                                                       
        ) ;
      
    if (UserECMFileExplorerSuite.isEnableJCR) {
      //Click on preferences icon
      addWebUnit(
        new ClickURLLinkUnit("ClickOnPreferences", "click on preferences icon").
        setURL("uicomponent=MainToolbar&op=preferences").                  
        addValidator(new ExpectFormIdValidator("preferencesForm"))      
      ) ; 
      addWebUnit(
        new SubmitFormUnit("SelectEnableJCRLikeStructure", "Select Enable JCR like structure and save").
        setFormId("preferencesForm").
        setCheckBox("checkbox",true).
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=saveSession"))
      ) ;
      //Save session
      addWebUnit(
        new ClickURLLinkUnit("SavedSession", "click on save Session button").
        setURL("&uicomponent=MainToolbar&op=saveSession").        
        addValidator(new ExpectTextValidator("All the changes have been saved"))      
      ) ;
    }                     
    //Delete upload file
    addWebUnit(
      new ClickURLLinkUnit("DeleteUploadFile", "click delete icon of upload file").
      setURL("uicomponent=UIContentManager&op=removeNode&objectId=/home/users/#{client.name}/test-folder/upload"). 
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentManager&op=checkin&objectId=/home/users/#{client.name}/test-folder/upload",0))
    ) ; 
       
    //Return to Drive selection
    addWebUnit(
      new ClickURLLinkUnit("SelectDrive", "select Drive button").
      setURL("&uicomponent=MainToolbar&op=selectDrive").                  
      addValidator(new ExpectTextValidator("Drives"))      
    ) ; 
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}