/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserViewReferencesSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page, view preferences and test all the basic actions" ;
  static String NAME = "UserViewReferencesSuite" ;
  String COMMENT  = "You must run AdminViewSuite and AdminDriveSuite before run this suite";
  
  public UserViewReferencesSuite() {    
    super(NAME, DESC) ;
    addWebSuite(new UserAddFolderSuite());       
    //Select Info tab
    addWebUnit(
      new ClickURLLinkUnit("SelectInfoTab", "click on info tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Info").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewReferences")).         
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewNodeType")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewPermissions")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewProperties"))
    ) ;
    //-----View Preferences
    addWebUnit(
      new ClickURLLinkUnit("ClickOnViewPreferences", "click on View Preferences button").
      setURL("&uicomponent=UIToolbar&op=viewReferences").          
      addValidator(new ExpectTextValidator("Workspace"))      
    ) ;    
    //-----Back to previous node
    addWebUnit(
      new ClickURLLinkUnit("BackToPreviousNode", "back to previous node").
      setURL("&uicomponent=UIReferencesList&op=PhaseId[1].cancel")            
    ) ;   
    //Select Drive
    addWebUnit(
      new ClickURLLinkUnit("SelectDrive", "select Drive button").
      setURL("&uicomponent=MainToolbar&op=selectDrive").                  
      addValidator(new ExpectTextValidator("Drives"))      
    ) ;   
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}