/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.jmx;

import condition.* ;
import suites.share.*;
import suites.share.CommonUnit ;
import suites.share.UserLoginSuite;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class Exomx extends WebUnitSuite {
  static String DESC = "Go to JMX Monitoring page and test all the basic actions" ;
  static String NAME = "Exomx" ;
  
  public Exomx() {    
    super(NAME, DESC) ;
    init("/Home/Monitoring") ;    
  }  
  public Exomx(String path) {
    super(NAME, DESC) ;
    init(path) ;
  }  
  public void  init(path) {    
		goToPage(path) ;
    addWebUnit(
      new ClickLinkWithText("ClickOnExomx", "click on exomx link").
      setTextLink("exomx").      
      addCondition(new NoLinkWithURLCondition("&uicomponent=UINavigator&op=selectCategory&objectId=monitor:type")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UINavigator&op=selectCategory&objectId=monitor:type"))
    ) ;     
    //Click on monitor link
    addWebUnit(
      new ClickURLLinkUnit("ClickOnMonitor", "click on monitor link").
      setURL("&uicomponent=UINavigator&op=selectCategory&objectId=monitor:type").
      addCondition(new NoLinkWithTextCondition("PortletContainerMonitor")).
      addValidator(new ExpectLinkWithTextValidator("PortletContainerMonitor")).
      addValidator(new ExpectLinkWithTextValidator("LogService"))
    ) ;
    //-----Click on PortletContainerMonitor link    
    addWebUnit(
      new ClickLinkWithText("ClickOnPortletContainerMonitor", "click on PortletContainerMonitor link").
      setTextLink("PortletContainerMonitor").      
      addValidator(new ExpectLinkWithURLValidator("&op=showPortletAppMonitor&portletAppName=web"))
    ) ;
    //----------Click on Web link    
    addWebUnit(
      new ClickURLLinkUnit("ClickOnWeb", "click on Web link").
      setURL("&op=showPortletAppMonitor&portletAppName=web").    
      addCondition(new NoLinkWithTextCondition("&op=showPortletMonitor&portletAppName=web&portletName=LanguageSelector")).
      addValidator(new ExpectLinkWithURLValidator("&op=showPortletMonitor&portletAppName=web&portletName=LanguageSelector"))
    ) ;
    //----------Click on LanguageSelector link    
    addWebUnit(
      new ClickURLLinkUnit("ClickOnLanguageSelector", "click on LanguageSelector link").
      setURL("&op=showPortletMonitor&portletAppName=web&portletName=LanguageSelector").    
      addValidator(new ExpectTextValidator("Time Range"))
    ) ;
    //----------Click on standard tab    
    addWebUnit(
      new ClickURLLinkUnit("ClickOnStandard", "click on Standard tab").
      setURL("&uicomponent=UIMBean&op=selectNode&objectId=UIStandardViewMBean").      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIStandardViewMBean&op=execute&objectId="))
    ) ;
    //---------------Click on execute link    
    addWebUnit(
      new ClickURLLinkUnit("ClickOnExecute", "click on execute tab").
      setURL("&uicomponent=UIStandardViewMBean&op=execute&objectId=").      
      addValidator(new ExpectFormIdValidator("operation"))
    ) ;    
    //-----Click on LogService link    
    addWebUnit(
      new ClickLinkWithText("ClickOnLogService", "click on PortletContainerMonitor link").
      setTextLink("LogService").      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIAdvancedViewMBean&op=selectNode&objectId=UILogConfig")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIAdvancedViewMBean&op=selectNode&objectId=UILogError")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIAdvancedViewMBean&op=selectNode&objectId=UILog"))
    ) ;
    //----------Click on Log Config
    addWebUnit(
      new ClickURLLinkUnit("ClickOnLogConfig", "click on Log Config tab").      
      setURL("&uicomponent=UIAdvancedViewMBean&op=selectNode&objectId=UILogConfig").      
      addValidator(new ExpectFormIdValidator("configForm"))      
    ) ;  
    //----------Click on Log Error
    addWebUnit(
      new ClickURLLinkUnit("ClickOnLogError", "click on Log Error tab").      
      setURL("&uicomponent=UIAdvancedViewMBean&op=selectNode&objectId=UILogError").      
      addValidator(new ExpectFormIdValidator("logForm"))      
    ) ;      
    //----------Click on standard tab    
    addWebUnit(
      new ClickURLLinkUnit("ClickOnStandard", "click on Standard tab").      
      setURL("&uicomponent=UIMBean&op=selectNode&objectId=UIStandardViewMBean").      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIStandardViewMBean&op=execute&objectId="))      
    ) ;
    //---------------Click on execute link    
    addWebUnit(
      new ClickURLLinkUnit("ClickOnExecute", "click on execute tab").
      setURL("&uicomponent=UIStandardViewMBean&op=execute&objectId=").      
      addValidator(new ExpectFormIdValidator("operation"))
    ) ;       
  }               
  public java.util.List getRequiredSuites() { 
  	String[] roles = ["user", "admin"] ;
   	return [new UserLoginSuite(CommonUnit.NAME_EXO_ADMIN, "exo", roles)] ;
  }  
}