/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.share ;

import condition.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Hoa  Pham
 *          hoapham@exoplatform.com,phamvuxuanhoa@yahoo.com
 * Nov 8, 2005
 */
public class SearchPermissionSuite extends WebUnitSuite {
  public SearchPermissionSuite(String formId, String type, String searchtype, String membership, String group) {
    super("SearchPermissionSuite", "Search permission an grant to some field") ;
    
   addWebUnit(
       new SubmitFormUnit("ClickSearch${type}Permission", "Click search page link").
       setFormId(formId).
       setField("op",searchtype).
       addValidator(new ExpectTextValidator("Group Id"))
   ) ;
   //-----this unit will run if MembershipType isn't activated-----
   addWebUnit(
       new ClickURLLinkUnit("ClickSelectMembershipType", "Tell web client select membership on this page").
       setURL("uicomponent=UIExoPermissionBrowser&op=").
       addValidator(new ExpectLinkWithURLValidator("uicomponent=UIExoPermissionBrowser&op=select"))       
   ) ;   
   addWebUnit(
       new ClickURLLinkUnit("ClickSelectPermission", "Tell web client click'select' on this page").
       setURL("uicomponent=UIExoPermissionBrowser&op=selectGroup&objectId=/${group}").       
       addValidator(new ExpectTextValidator("Permission"))
   ) ;
  }
}