import java.net.URL ;
import java.net.URLClassLoader ;
import groovy.util.XmlSlurper;
import java.io.FileReader;

String filePath = System.getProperty("user.home")+"/tomcat.xml"
def document = new XmlSlurper().parse ( new FileReader ( filePath ) )
def parameters = document.parameter;
String javaHome=parameters.find{ it['@name'] == 'JAVA_HOME' }.path.text()
String catalinaHome=parameters.find{ it['@name'] == 'CATALINA_HOME' }.path.text()

ClassLoader sysClassLoader = ClassLoader.getSystemClassLoader();

String catalinaBase = catalinaHome ;

System.setProperty("catalina.base", catalinaBase) ;
System.setProperty("catalina.home", catalinaHome) ;
System.setProperty("java.io.tmpdir", catalinaHome + "/temp") ;
System.setProperty("org.apache.commons.logging.Log", "org.apache.commons.logging.impl.SimpleLog") ;
System.setProperty("java.security.auth.login.config", catalinaHome + "/conf/jaas.conf") ;

sysClassLoader.addURL(new URL("file:" + javaHome + "/lib/tools.jar"));
sysClassLoader.addURL(new URL("file:" + catalinaHome + "/bin/commons-logging-api.jar"));

URL[] urls = [ new URL("file:" + catalinaHome + "/bin/bootstrap.jar") ] ;
ClassLoader contextLoader= Thread.currentThread().getContextClassLoader();
ClassLoader tomcatLoader = new URLClassLoader(urls, contextLoader);

Thread.currentThread().setContextClassLoader(tomcatLoader);

Class bootstrap =  tomcatLoader.loadClass("org.apache.catalina.startup.Bootstrap") ;
def instance =  bootstrap.newInstance() ;

instance.init() ;
instance.start() ;
//    instance.stop() ;
//    System.exist(1) ;

Thread.currentThread().setContextClassLoader(contextLoader);

